/*
 * Licensed Materials - Property of IBM
 *
 * Copyright IBM Corporation 2007, 2009. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA DP Schedule Contract with IBM Corp.
 */
var CODE_BACKSPACE = 8;
var CODE_TAB       = 9;
var CODE_ENTER     = 13;
var CODE_PAGEUP    = 33;
var CODE_PAGEDOWN  = 34;
var CODE_END       = 35;
var CODE_HOME      = 36;
var CODE_ARROWLEFT = 37;
var CODE_ARROWRIGHT= 39;
var CODE_ARROWUP   = 38;
var CODE_ARROWDOWN = 40;
var CODE_INSERT    = 45;
var CODE_DELETE    = 46;
var CODE_A		   = 65;
var adjustCaretOnKeyUp = false;
var isFldreversed = false;
var curPos = 1;
var selectionStart;
var autoPush = false;
var pushMode = false;
var rightPushBound = 0;
var leftPushBound = 0;
var layerGuess = false;
var swapChar = 0;
var hadnoFocus = true;
var preventAltNumpad = false;
var isOverwriteMozilla = false;
var isArabic = false;
var isLinux = false;
var isIE = false;
var LRO = String.fromCharCode(8237);
var RLO = String.fromCharCode(8238);
var fieldStart = 0;
var CR;
var hint;
var LF = '\n';
var fOnFocus = new Function("handleFocus(this);");
var fOnMouseOut = new Function("handleMouseOut(this);");
var fOnDblClick = new Function("handleDblClick(this);");
var fOnBlur = new Function("handleBlur(this);");
var fOnCut = new Function("handleCut(this);");
var fOnCopy = new Function("handleCopy(this);");
var fOnPaste = new Function("handlePaste(this);");
var fOnSubmit = new Function("handleSubmit()");
/////
function addEventHandlers() {
    isLinux = (navigator.platform.indexOf("Linux") != -1) ? true : false;

    if(isLinux) {
        if(!NN)
            alert("Emulation of Arabic/Hebrew host sessions works correctly only on Microsoft Explorer or Netscape/Mozilla browser");
        else {
            index = navigator.userAgent.indexOf("Netscape/");
            if((index > 0) && (parseInt(navigator.userAgent.substring(index+9,index+10)) < 7))
                alert("To have full Bidi support use Netscape version 8 or above");
        }
    }
    else if (navigator.appName == 'Microsoft Internet Explorer')
        isIE = true;

	CR = (isIE) ? "\r\n" : "\n";

    isArabic = false;
    var hint;
    if(isIE) {
        var hint = document.createElement("<div dir='ltr' id='hint' style=\"BACKGROUND-COLOR: rgb(255,255,128); COLOR: black; BORDER-BOTTOM-STYLE: groove; BORDER-LEFT-STYLE: groove; BORDER-RIGHT-STYLE: groove; BORDER-TOP-STYLE: groove; FONT-FAMILY: serif; FONT-SIZE: x-small; HEIGHT: 80px; LEFT: 1px; POSITION: absolute; TOP: 1px; VISIBILITY: hidden; WIDTH: 250px; Z-INDEX: 1\"></div>");
        hint.innerText = "Field reverse-'Alt+Numpad Numlock'\nAuto push-'Alt+Numpad /'\nPush on-'Shift+Numpad Numlock'\nPush off-'Shift+Numpad /'";
    }
    else {
        hint = document.createElement("<div>");
        hint.setAttribute("dir","ltr");
        hint.setAttribute("id","hint");
        hint.setAttribute("style","BACKGROUND-COLOR: rgb(255,255,128); COLOR: black; BORDER-BOTTOM-STYLE: groove; BORDER-LEFT-STYLE: groove; BORDER-RIGHT-STYLE: groove; BORDER-TOP-STYLE: groove; FONT-FAMILY: serif; FONT-SIZE: small; HEIGHT: 80px; LEFT: 1px; POSITION: absolute; TOP: 1px; VISIBILITY: hidden; WIDTH: 250px; Z-INDEX: 1");
        if(isLinux)
            hint.innerHTML =  "Field reverse-'Shift+Numpad 4'<br\>Auto push-'Shift+Numpad 6'<br\>Push on-'Shift+Numpad 7'<br\>Push off-'Shift+Numpad 8'";
        else            
            hint.innerHTML =  "Field reverse-'Alt+Numpad Numlock'<br\>Auto push-'Alt+Numpad /'<br\>Push on-'Shift+Numpad Numlock'<br\>Push off-'Shift+Numpad /'";        
    }

    var body = document.getElementsByTagName("BODY");
    body[0].appendChild(hint);

    var forms = document.getElementsByTagName("FORM");
    var resolvedStyle = "ltr";
    if(forms != null) {
        forms[0].onsubmit = fOnSubmit;

    	if (window.getComputedStyle){
    		resolvedStyle = window.getComputedStyle(forms[0], "").getPropertyValue("direction");
    	} else if (forms[0].currentStyle) {
    		resolvedStyle = eval("forms[0].currentStyle.direction");
    	}
    }

    var elements = document.getElementsByTagName("textarea");
    var j;
    for(j=0 ;j < elements.length; j++) {
        if((elements[j].value.charAt(0) == LRO) || (elements[j].value.charAt(0) == RLO)){
            attachHandlers(elements[j],resolvedStyle);
            if(elements[j].maxLength < 0 || elements[j].maxLength > 10000000)   
                elements[j].maxLength = 10000000; 
                            
            elements[j].value = elements[j].value.substring(1);
            elements[j].style.unicodeBidi = "bidi-override";
            if(isIE)
            	elements[j].style.wordWrap = "normal";
            else
            	elements[j].setAttribute("wrap", "off");
        }
    }

    var elements = document.getElementsByTagName("input");
    for(j=0 ;j < elements.length; j++) {
        if((elements[j].type == "text") && 
            (elements[j].value.charAt(0) == LRO || elements[j].value.charAt(0) == RLO) ){
            attachHandlers(elements[j],resolvedStyle);
            if(elements[j].maxLength < 0 || elements[j].maxLength > 10000000)   
                elements[j].maxLength = 1000000; 
                           
            elements[j].maxLength++;  
        }
    }
}
///////
function attachHandlers(obj,resolvedStyle) {
    if(isIE) {
        obj.onkeypress= new Function("handleKeyPress(event);");;
        obj.onkeydown= new Function("handleKeyDown(event);");
        obj.onkeyup= new Function("handleKeyUp(event);");
        obj.onmouseup=new Function("handleMouseUp(event,this);");;
        obj.onmousedown= new Function("handleMouseDown(event);");
        obj.onselect= new Function("handleSelect(event);");               
        obj.oncontextmenu= new Function("handleContextmenu();"); //shensis                      
    }else{
        obj.onkeypress= handleKeyPress;
        obj.onkeydown= handleKeyDown;
        obj.onkeyup= handleKeyUp;
        obj.onmouseup= handleMouseUp;
        obj.onmousedown= handleMouseDown;
        obj.onselect= handleSelect;           
    }
    
    if((resolvedStyle == "rtl") || (obj.value.charAt(0) == RLO)){
        obj.style.direction = "rtl";
        obj.style.textAlign= "right";
        reverseText(obj);  
        if(obj.value.charAt(0) == LRO)  
        	obj.value = RLO + obj.value.substring(1);        
    } else {
        obj.style.direction = "ltr";
        obj.style.textAlign= "left";
    }

    obj.onfocus=fOnFocus;
    obj.ondblclick=fOnDblClick;
    obj.onmouseout=fOnMouseOut;
    obj.onblur=fOnBlur;
    obj.oncut=fOnCut;
    obj.oncopy=fOnCopy;
    obj.onpaste=fOnPaste;
    obj.style.position = "relative";
}
///////
function handleSelect(event) {  
    if(isIE){
        var obj = event.srcElement;
        if(document.selection.createRange().text.length == obj.value.length) {
            handleDblClick(obj);
            preventDefault(event);
        }
    }
    else {
        var obj = event.target;
        if((obj.selectionEnd - obj.selectionStart) == obj.value.length) {
            handleDblClick(obj);
            preventDefault(event);
        }
    }
}
///////
function isOverWriteMode() {
    if (isIE)
        return document.queryCommandValue("OverWrite");
    else
        return isOverwriteMozilla;
}
///////
function handleSubmit() {
    var temp,text;
    var elements = document.getElementsByTagName("textarea");
    for(var j=0;j < elements.length; j++) {
        if(elements[j].style.unicodeBidi == "bidi-override") {
            if(elements[j].style.direction == "rtl") {
                elements[j].style.visibility = 'hidden';
                reverseText(elements[j]);
            }
        }
    }

    var elements = document.getElementsByTagName("input");
    for(var i=0;i < elements.length; i++) {
        if(elements[i].type == "text") {
            elements[i].style.visibility = 'hidden';
            if(elements[i].value.charAt(0) == RLO) {  
                reverseText(elements[i]);
                elements[i].value = elements[i].value.substring(1);                
            }
            else if(elements[i].value.charAt(0) == LRO)
                elements[i].value = elements[i].value.substring(1);
        }
    }
}
////
function reorderText(obj,text,isCopyOperation) {  
    var jr = new JSReorder();
    var resultText = "";
    if(isCopyOperation && ((obj != null) && (obj.style.direction == "rtl")) ) {
        var len = text.length;
        for(i = 0;i < len;i++) {
            symbol = text.charAt(len - i - 1);
            symbol = doSymSwap(symbol);
            resultText += symbol;
        }
    }
    else
        resultText = text;

        resultText = jr.doReorder(resultText);

    if(!isCopyOperation && ((obj != null) && (obj.style.direction == "rtl")) ) {
        var len = text.length;
        text = resultText;
        resultText = "";
        for(i = 0;i < len;i++) {
            symbol = text.charAt(len - i - 1);
            symbol = doSymSwap(symbol);
            resultText += symbol;
        }
    }
    return resultText;
}
////
function processCopy(obj) {
    if(isIE) {
        range = document.selection.createRange();
        text = range.text;
    }
    else
        text = obj.value.substring(obj.selectionStart,obj.selectionEnd);

    if((text.charAt(0) == LRO) || (text.charAt(0) == RLO))
        text = text.substring(1);

    textToClipboard = reorderText(obj,text,true);

    if(isIE) {
        window.clipboardData.setData("Text", textToClipboard);
        return true;
    }
}
//////
function ajustCaretPositions(event_,obj) {
    if((fieldStart > 0) && (selectionStart == curPos)) { //for selection by context menu
        preventEraseMarker(obj);
        var selection = getCaretPos(event_,obj);
        if (selection){
        	selectionStart = Math.min(selection[0],selection[1]);
        	curPos = Math.max(selection[0],selection[1]);
        }
    }
}
//////
function handleCopy(obj) {
    preventDefault(event);
    ajustCaretPositions(event,obj);
    return processCopy(obj);
}
//////
function handleCut(obj) {
    ajustCaretPositions(event,obj);

    if(pushMode) {
        if(isIE)
            leftPushBound -= Math.abs(selectionStart - curPos);
        else
            leftPushBound -= Math.abs(obj.selectionStart - obj.selectionEnd);
    }

    var ret = processCopy(obj);
    if(!ret) return false;

    if(isIE) {
        curPos = Math.min(selectionStart,curPos);
        selectionStart = curPos;
        preventDefault(event);
        range = document.selection.clear();
    }
    else {
        curPos = obj.selectionStart;
        obj.value = obj.value.substring(0,curPos) + obj.value.substring(obj.selectionEnd);
        obj.setSelectionRange(curPos,curPos);
    }

    return true;
}
////
function handlePaste(obj) {
    if(event.returnValue == false) return;

    ajustCaretPositions(event,obj);

    preventDefault(event);
    var range = document.selection.createRange();
    var clipboardText = window.clipboardData.getData("Text");
    selectionStart = Math.min(selectionStart, curPos);
    range.text = reorderText(obj,clipboardText,false);

    selectionStart = curPos = selectionStart + clipboardText.length;

    if(fieldStart > 0)
    	adjustCaretOnKeyUp = true;

    if(pushMode)   
    	toggleFieldOrient(obj,true,false);
}
////
function handleDblClick(obj) {  
    fieldStart = (obj.type.toLowerCase() == 'textarea') ? 0 : 1;
    selectionStart = fieldStart;
    curPos = obj.value.length;
    if(pushMode) { 
    	toggleFieldOrient(obj,false,false);
    	pushMode = false;
    }
    setSelectedRange(obj,selectionStart,curPos);
}
////
function getCaretPos(event,obj) {
    if(!isIE) {
        return new Array(event.target.selectionStart, event.target.selectionEnd);
    }
    else {
        var range = document.selection.createRange().duplicate();
        var range2 = range.duplicate();
        var rangeLength = range.text.length;
        if (obj.type == "textarea")
            range2.moveToElementText(obj);
        else
            range2.expand('textedit');

        var isLeftBoundaryPosition = range2.offsetLeft == range.offsetLeft;
        while (range.compareEndPoints('StartToStart', range2) > 0) {
            range.moveStart('character', -1);
        }

        var position = range.text.length;
        if (obj.type == "textarea" && (obj.value.charAt(position) == '\r')) {
        	if(((event.type != "mouseup" || rangeLength == 0) && isLeftBoundaryPosition) //mouse click or up/down
        	 ||(event.type == "mouseup" && !isLeftBoundaryPosition && (event.offsetX < 5) && (event.offsetX > 0))) //mouse selection
				position += 2;
        }
        return new Array(position - rangeLength, position);
    }
}
////
function handleMouseDown(event) {
    if(event.button == 2) {
        var hint = document.getElementById("hint");
        if(hint != null) {
            var hintElement = (hint.length > 0) ? hint[0] : hint;

            hintElement.style.left=(event.clientX >= hint.scrollWidth) ? (event.clientX - hint.scrollWidth) : 0;
            hintElement.style.top=event.clientY;
            hintElement.style.visibility = "visible";
        }
    }

    if(isIE) {
        var obj = event.srcElement;
        fieldStart = (obj.type == "textarea") ? 0 : 1;


        if(selectionStart != curPos)
        	setSelectedRange(obj,fieldStart,fieldStart);

    }
}
////
function handleMouseUp(event,obj) {
    if(!obj)
        obj = this;

    var hint = document.getElementById("hint");
    if(hint != null) {
        if(hint.length > 0)
            hint[0].style.visibility = "hidden";
        else
            hint.style.visibility = "hidden";
    }

    var selection = getCaretPos(event,obj);
    if (selection && (!isIE || event.button != 2)){ //shensis
        selectionStart = Math.min(selection[0],selection[1]);
        curPos = Math.max(selection[0],selection[1]);
        if(fieldStart > 0 && selectionStart == 0) {
           if(isIE) {
                var rng = document.selection.createRange();
                rng.moveStart('character', fieldStart);
                selectionStart = fieldStart;
                if(curPos == 0)
                    curPos = fieldStart;
    
                rng.select();
            }
            else {
             	if(curPos != selectionStart)             
            	    obj.setSelectionRange(selectionStart + 1,curPos);
             	else
            	    obj.setSelectionRange(selectionStart + 1,curPos + 1);      	            	
            }
        }
    }

    if(pushMode && ((curPos > leftPushBound)||(selectionStart < rightPushBound)))
        toggleFieldOrient(obj,true,false);
}
////
function handleContextmenu(){  //shensis
 try{
    var obj = event.srcElement;
    var selection = getCaretPos(event,obj);
    if(selection) {
        selectionStart = Math.min(selection[0],selection[1]);
        curPos = Math.max(selection[0],selection[1]);			    
    }	    
 } catch(e){}	
}
////
function handleBlur(obj) {
    if(!isLinux || !preventAltNumpad) {
        if(pushMode) {
            toggleFieldOrient(obj,false,false);
            pushMode = false;
        }

        if (isFldreversed)
            processFieldReverse(obj,false);
    }
}
////
function handleFocus(obj) {
    var text = obj.value;
    isFldreversed = false;
    fieldStart = (obj.type == "textarea") ? 0 : 1;
    if(isIE) {
        var selection = getCaretPos(event,obj);
        if (selection){
	        selectionStart = Math.min(selection[0],selection[1]);
	        curPos = Math.max(selection[0],selection[1]);
            if(curPos == 0 && fieldStart > 0) {        	
                rng = document.selection.createRange();
                rng.moveStart('character', fieldStart);
                rng.select();
                selectionStart = curPos = fieldStart;
            }        	
        }
    }

    if(text.length == 0)
        obj.style.textAlign = (obj.style.direction == "ltr") ? "left" : "right";

    if(isLinux && (curPos > 0))
        obj.setSelectionRange(curPos,curPos);

}
///
function handleMouseOut(obj) {
    var hint = document.getElementById("hint");
    if(hint != null) {
        if(hint.length > 0)
            hint[0].style.visibility = "hidden";
        else
            hint.style.visibility = "hidden";
    }
}
/////
function swapBrackets(event,fieldDirection,swapped) {
    if(isLinux) {
        if(fieldDirection ^ (layerGuess && !isArabic) ) {
            if(swapped == 40)
                swapped =  41;
            else if(swapped == 41)
                swapped = 40;
            else if(swapped == 60)
                swapped = 62;
            else if(swapped == 62)
                swapped = 60;
            else if(swapped == 91)
                swapped = 93;
            else if(swapped == 93)
                swapped = 91;
            else if(swapped == 123)
                swapped = 125;
            else if(swapped == 125)
                swapped = 123;
        }

        return swapped;
    }
    else
    if(fieldDirection) {
        if(swapChar == 219) {
            if (isArabic)
                swapped = 62;
            else
                swapped = (event.shiftKey) ? 125 : 93;
        }
        else if(swapChar == 221) {
            if (isArabic)
                swapped = 60;
            else
                swapped = (event.shiftKey) ? 123 : 91;
        }
        else if(swapChar == 48)
            swapped = 40;
        else if(swapChar == 57)
            swapped = 41;
        else if(swapChar == 188)
            swapped = 62;
        else if(swapChar == 190)
            swapped = 60;
    }
    else {
        if(swapChar == 219) {
            if (isArabic)
                swapped = 60;
            else
                swapped =  (event.shiftKey) ? 123 : 91;
        }
        else if(swapChar == 221) {
            if (isArabic)
                swapped = 62;
            else
                swapped =  (event.shiftKey) ? 125 : 93;
        }
        else if(swapChar == 48)
            swapped = 41;
        else if(swapChar == 57)
            swapped = 40;
        else if(swapChar == 188)
            swapped = 60;
        else if(swapChar == 190)
            swapped = 62;
    }

    swapChar = 0;
    return swapped;
}
//////
function handleKeyPress(event) {
    if(preventAltNumpad || (event.returnValue == false)) {
        preventDefault(event);
        return;
    }

    var replacedKey = null;
    var obj = (isIE) ? event.srcElement : event.target;
    charClass = fieldDirection = (obj.style.direction == "rtl");

    if(isIE) {
        if(event.returnValue == false)
            return;

        event.keyCode = swapBrackets(event,fieldDirection,event.keyCode);
        ieKey = event.keyCode;

        if(isArabic && layerGuess && (ieKey > 47) && (ieKey < 58))//Arabic, transform into Hindi
            ieKey = event.keyCode = ieKey + 1584;
    }
    else {
        ieKey = event.charCode;

        if(event.keyCode == CODE_INSERT) {
            isOverwriteMozilla = !isOverwriteMozilla;
        }
        else if((ieKey > 31) & !event.altKey & !event.ctrlKey) { //regular character
            charCode = swapBrackets(event,fieldDirection,event.charCode);
            if(charCode != ieKey) {
                replacedKey = charCode;
            }
            else if(isArabic && layerGuess && (ieKey > 47) && (ieKey < 58)) {//Arabic, transform into Hindi
                replacedKey = ieKey + 1584;
            }
        }
    }

    if((event.keyCode == CODE_ENTER) && (obj.rows == 1)){
        preventDefault(event);
        return;
    } 

    if(!isIE && ((event.keyCode == 8) || (event.keyCode == 46)) )
        return;

    if(((ieKey > 64) & (ieKey < 91)) || ((ieKey > 96) & (ieKey < 123)))
        layerGuess = charClass = false;  //English
    else if(ieKey > 1487) {
        layerGuess = charClass = true;
        if(ieKey > 1547)
            isArabic = true;
    }


    if(autoPush) {
        if(fieldDirection && ((ieKey > 47) && (ieKey < 58)) ) {
            if(!layerGuess || (obj.style.textAlign == "right"))
                charClass = false;  //English (Numerals)
        }

        if(fieldDirection != charClass) { //enter/leave push mode
            curPos = (isIE) ? curPos : obj.selectionEnd;
            toggleFieldOrient(obj,true,pushMode && (curPos == leftPushBound));
        }
    }

    if((ieKey > 31) && !event.altKey && !event.ctrlKey) { //regular character
        preventEraseMarker(obj);
        var cursorPos = (isIE) ? curPos : obj.selectionStart;
        var selectionLength = (isIE) ? Math.abs(selectionStart - curPos) : obj.selectionEnd - obj.selectionStart;
        if(!isOverWriteMode() || (selectionLength > 0)) {  
            if(obj.value.length - selectionLength >= obj.maxLength) {
                preventDefault(event);
                return;
            }
        }
        else {
            if (cursorPos >= obj.maxLength) {
                preventDefault(event);
                return;
            }
        }

        if(pushMode) {
            if(!isOverWriteMode() || (leftPushBound == cursorPos) || (selectionLength > 0))   
                leftPushBound += 1 - selectionLength;
        }

        if(isIE) {
            if(selectionLength > 0) {
                preventDefault(event);
                var range = document.selection.createRange();
                range.text = String.fromCharCode(ieKey);
                range.select();
            }
            selectionStart = curPos = Math.min(selectionStart,curPos) + 1;
        }
        else {
            if(isLinux && fieldDirection && isArabic && (ieKey > 1487)) {
                replacedKey = (replacedKey != null) ? replacedKey : ieKey;
                event.preventDefault();
                curPos = obj.selectionStart;
                if(isOverWriteMode() && (obj.selectionStart == obj.selectionEnd))
                    text = obj.value.substring(0,obj.selectionStart) + String.fromCharCode(replacedKey) + obj.value.substring(obj.selectionEnd+1);
                else
                    text = obj.value.substring(0,obj.selectionStart) + String.fromCharCode(replacedKey) + obj.value.substring(obj.selectionEnd);

                obj.value = ara_type(obj.selectionStart,text,fieldDirection);
                obj.setSelectionRange(curPos+1,curPos+1);
            }
            else if((replacedKey != null) || isOverWriteMode()) {
                replacedKey = (replacedKey != null) ? replacedKey : ieKey;
                event.preventDefault();
                replaceFieldText(obj,replacedKey);
            }
        }
    }
}
/////
function replaceFieldText(obj,characterCode) {
    curPos = obj.selectionStart;
    if(isOverWriteMode() && (obj.selectionStart == obj.selectionEnd))
        obj.value = obj.value.substring(0,obj.selectionStart) + String.fromCharCode(characterCode) + obj.value.substring(obj.selectionEnd+1);
    else
        obj.value = obj.value.substring(0,obj.selectionStart) + String.fromCharCode(characterCode) + obj.value.substring(obj.selectionEnd);

    obj.setSelectionRange(curPos+1,curPos+1);
}

/////
function handleKeyUp(event) {
    var ieKey = event.keyCode;
    var obj = (isIE) ? event.srcElement : event.target;
    fieldDirection = (obj.style.direction == "ltr") ? false : true;

    if(!isIE)
        curPos = obj.selectionStart;

    if (((ieKey == CODE_ARROWLEFT) && (fieldDirection == false))||((ieKey == CODE_ARROWRIGHT) && (fieldDirection == true))) {
        if(pushMode && (curPos < rightPushBound))
            toggleFieldOrient(obj,true,false);
    }
    else if (((ieKey == CODE_ARROWRIGHT) && (fieldDirection == false))||((ieKey == CODE_ARROWLEFT) && (fieldDirection == true))) {
        if(pushMode && (curPos > leftPushBound))
            toggleFieldOrient(obj,true,false);
    }

    if (ieKey == CODE_ARROWUP || ieKey == CODE_ARROWDOWN || (event.shiftKey && (ieKey == CODE_HOME || ieKey== CODE_END))) {
   	if(pushMode)   
    		toggleFieldOrient(obj,true,false);

        var selection = getCaretPos(event,obj);
        if (selection){
        	selectionStart = Math.min(selection[0],selection[1]);
        	curPos = Math.max(selection[0],selection[1]);
        }
    }
    else if (ieKey == CODE_HOME || ieKey == CODE_PAGEUP)
        processHome(obj,event);
    else if (ieKey == CODE_END || ieKey == CODE_PAGEDOWN)
        processEnd(obj,event);
    else if(adjustCaretOnKeyUp){
    	setSelectedRange(obj,selectionStart,curPos);
    	adjustCaretOnKeyUp = false;
    }
}
/////
function handleKeyDown(event) {
    var ieKey = event.keyCode;
    var obj = (isIE) ? event.srcElement : event.target;

    if(ieKey == 18)
        preventAltNumpad = true;
    else if(!event.altKey)
        preventAltNumpad = false;

    fieldDirection = (obj.style.direction == "ltr") ? false : true;

    if(event.shiftKey && (ieKey == 48 || ieKey == 57))
        swapChar = ieKey;
    else if((ieKey == 219)||(ieKey == 221)) {
        if(isArabic) {
            if(event.shiftKey && layerGuess)
                swapChar = ieKey;
        }
        else
            swapChar = ieKey;
    }
    else if(event.shiftKey && (ieKey == 188 || ieKey == 190)) {
        swapChar = (isArabic) ? 0 : ieKey;
    }

    if(event.shiftKey)
        processPush(obj,ieKey);

    if((!isLinux && event.shiftKey && event.altKey) || (isLinux && (ieKey == 18)) ) {
        layerGuess = !layerGuess;
    }

    if((event.altKey && !isLinux) || (event.shiftKey && isLinux)) {
        if(((ieKey == 111) && !isLinux) || ((ieKey == 102) && isLinux)) {  //Toggle Autopush
            autoPush = !autoPush;
            if(pushMode)  
            	toggleFieldOrient(obj,true,false);

            preventAltNumpad = true;
        }
        else if(((ieKey == 144) && !isLinux) || ((ieKey == 100) && isLinux)) {  //Field reverse
            processFieldReverse(obj,true);
            preventAltNumpad = true;
        }
    }
    else if (ieKey == CODE_BACKSPACE) {
        processBackspace(obj,event);
    }
    else if (ieKey == CODE_DELETE) {
        processDelete(obj);
    }
    else if(isIE) {
        if(event.ctrlKey & (ieKey == CODE_A)) { //Ctrl+a - select all
            handleDblClick(obj);
        }
        else if(ieKey == CODE_ENTER) {
            if(pushMode)
                toggleFieldOrient(obj,false,false);

            if(obj.type == "textarea") 
            	selectionStart = curPos = curPos + 2;
        }
        else if ((ieKey == CODE_HOME)||(ieKey == CODE_END)||(ieKey == CODE_PAGEUP)||(ieKey == CODE_PAGEDOWN)) {
            if(!event.shiftKey)
            	preventDefault(event); //disable, process it in KeyUp
        }
        else if (((ieKey == CODE_ARROWLEFT) & (fieldDirection == 0))|((ieKey == CODE_ARROWRIGHT) & (fieldDirection == 1))) {
            processLeftarrow(obj);
        }
        else if (((ieKey == CODE_ARROWRIGHT) & (fieldDirection == 0))|((ieKey == CODE_ARROWLEFT) & (fieldDirection == 1))) {
            processRightarrow(obj);
        }
    }
    else if (event.ctrlKey && (ieKey == 88 || ieKey == 67 || ieKey == 86)) { //copy/paste/cut for firefox
    	preventEraseMarker(obj);
    }
}
/////
function preventDefault(event) {
    if(isIE)
        event.returnValue = false;
    else
        event.preventDefault();
}
////
function doSymSwap(symbol) {
    switch(symbol)
    {
        case "(":
            symbol = ")";
            break;
        case ")":
            symbol = "(";
            break;
        case "{":
            symbol = "}";
            break;
        case "}":
            symbol = "{";
            break;
        case "[":
            symbol = "]";
            break;
        case "]":
            symbol = "[";
            break;
        case "<":
            symbol = ">";
            break;
        case ">":
            symbol = "<";
            break;
    }
    return symbol;
}
////
function setSelectedRange(obj,selectionStartMod,curPosMod){
    if(isIE) {
        var range = obj.createTextRange();
        if (range){
            if (obj.type == "textarea") { 
                range.moveToElementText(obj);
                len = curPosMod;				
                for(var i = fieldStart; i < len; i++){
                    if((obj.value.charAt(i) == '\r')) {
                        selectionStartMod--;
                        curPosMod--;
                    }
                }
			}
            else
                range.expand('textedit');
    
            range.collapse();
            range.moveEnd('character', curPosMod);
            range.moveStart('character', selectionStartMod);
            range.select();
        }
    } else {
        obj.setSelectionRange(selectionStartMod,curPosMod);
    }
}
////
function processHome(obj,event) {
    var boundaries = getLineBoundaries(obj);
    var lineStart = (obj.type == "textarea") ? boundaries[0] + 1 : boundaries[0];
    var lineEnd = (obj.type == "textarea") ? boundaries[1] : boundaries[1] + 1;
    if(pushMode)
        selectionStart = curPos = lineEnd;
    else
        selectionStart = curPos = lineStart;

    setSelectedRange(obj,selectionStart,curPos);

    if(pushMode & (curPos > leftPushBound))
        toggleFieldOrient(obj,true,false);

    preventDefault(event);
}
////
function processEnd(obj,event) {
    var boundaries = getLineBoundaries(obj);
    var lineStart = (obj.type == "textarea") ? boundaries[0] + 1 : boundaries[0];
    var lineEnd = (obj.type == "textarea") ? boundaries[1] : boundaries[1] + 1;
    if(pushMode)
        selectionStart = curPos = lineStart;
    else
        selectionStart = curPos = lineEnd;

    setSelectedRange(obj,selectionStart,curPos);

    if(pushMode & (curPos < rightPushBound))
        toggleFieldOrient(obj,true,false);

    preventDefault(event);
}
////
function getLineBoundaries(obj) {
    var len = obj.value.length;
    var selectionStart_ = (isIE) ? selectionStart : obj.selectionStart;

    var lineStart = fieldStart, lineEnd = len - 1;
    if (obj.type == "textarea") {
        for(lineStart = selectionStart_; lineStart >= fieldStart; lineStart--){
            if(obj.value.charAt(lineStart) == LF)
                break;
        }
    
        for(lineEnd = curPos; lineEnd < len; lineEnd++){
            if((obj.value.charAt(lineEnd) == LF) || (obj.value.charAt(lineEnd) == '\r'))
                break;
        }
    }
	return new Array(lineStart,lineEnd);  
}
////
function toggleFieldOrient(obj,setCursor,jumpFromPushSegment) {
    var delta = 0;
    if(!isIE) {
        selectionStart = obj.selectionStart;
        curPos = obj.selectionEnd;
    }

    obj.style.direction = (obj.style.direction == "rtl") ? "ltr" : "rtl";
    if(obj.value.charAt(0) == LRO)
        obj.value = RLO + obj.value.substring(1);
    else if(obj.value.charAt(0) == RLO)
        obj.value = LRO + obj.value.substring(1);

    var boundaries = getLineBoundaries(obj);
    reverseText(obj);

    if(setCursor) {
        var lineStart = boundaries[0];
        var lineEnd = boundaries[1];

        pushMode = !pushMode;
        if(pushMode) {
            delta = Math.abs(selectionStart - curPos);
            leftPushBound = rightPushBound = selectionStart = lineEnd + 1 - Math.max(selectionStart,curPos) + lineStart;
            curPos = selectionStart + delta;
        }
        else {
            if(jumpFromPushSegment)
                curPos = rightPushBound;

			selectionStart = curPos = lineEnd + 1 - curPos + lineStart;
        }

        setSelectedRange(obj,selectionStart,curPos);
    }

}
////
function processPush(obj,ieKey) {
    if(((ieKey == 144) && !isLinux) || ((ieKey == 103) && isLinux)) {
        preventAltNumpad = true;
        if(!pushMode)
            toggleFieldOrient(obj,true,true);
    }
    else if(((ieKey == 111) && !isLinux) || ((ieKey == 104) && isLinux)) {
        preventAltNumpad = true;
        if(pushMode)
            toggleFieldOrient(obj,true,true);
    }
}
////
function reverse(text) {
    var len = text.length;
    var temp = "";
    for(i = 0;i < len;i++)  {
        symbol = text.charAt(len - i - 1);
        symbol = doSymSwap(symbol);
        temp += symbol;
    }
    return temp;
}
////
function reverseText(obj) {  
    text = obj.value;
    var temp = "";
    if(text.charAt(0) == LRO) {
        temp = LRO + temp;
        text = text.substring(1);
    }
    else if(text.charAt(0) == RLO) {
        temp = RLO + temp;
        text = text.substring(1);
    }       

    textPool = text.split(CR);
    temp += reverse(textPool[0]);
    for(j = 1;j < textPool.length; j++)
    temp += CR + reverse(textPool[j]);

    if(isLinux && isArabic)
        obj.value = ara_type(0,temp,(obj.style.direction == "rtl"));
    else
        obj.value = temp;
}
///
function processFieldReverse(obj,setCursor) {
    isFldreversed = !isFldreversed;
    var len = obj.value.length;

    if(!isIE)
        curPos = obj.selectionStart;

    if(len == fieldStart) {
        obj.style.textAlign = (obj.style.direction == "rtl") ? "left" : "right";
        setCursor = false;
    }

    var boundaries = getLineBoundaries(obj);
    toggleFieldOrient(obj,false,false);

    if(setCursor) {
        var lineStart = boundaries[0];
        var lineEnd = boundaries[1];

        selectionStart = curPos = lineEnd + 1 - curPos + lineStart;
        setSelectedRange(obj,selectionStart,curPos);
    }
}
////
function preventEraseMarker(obj) {
    if(fieldStart > 0) {
    	if(isIE) {
            rng = document.selection.createRange();
            var firstChar = rng.text.charAt(0);
            if((firstChar == LRO) || (firstChar == RLO)) {
                rng.moveStart('character', fieldStart);
                rng.select();
                curPos = fieldStart;
            }
    	}
    	else {
            if(obj.selectionStart < fieldStart)	{ 
             	if(obj.selectionStart != obj.selectionEnd)       
            	    obj.setSelectionRange(obj.selectionStart + 1,obj.selectionEnd);
             	else
            	    obj.setSelectionRange(obj.selectionStart + 1,obj.selectionEnd + 1);      	            	
            }            	
    	}
    }
}
////
function processDelete(obj) {
    if(!isIE) {
        selectionStart = obj.selectionStart;
        curPos = obj.selectionEnd;
    }

    if(pushMode) {
        if(selectionStart == curPos)
            leftPushBound--;
        else
            leftPushBound -= Math.abs(selectionStart - curPos);
    }

    preventEraseMarker(obj);

    if(isIE)
        selectionStart = curPos = Math.min(selectionStart,curPos);
}
//////
function processBackspace(obj,event) {
    if(isIE) {
        var range = document.selection.createRange();
        noSelection = ((range.text).length == 0) ;
    }
    else {
        selectionStart = obj.selectionStart;
        curPos = obj.selectionEnd;
        noSelection = (selectionStart == curPos);
    }

    if(noSelection) {
        if(curPos > fieldStart) {
            if(pushMode && (curPos <= rightPushBound)) {
                if(isIE)
                    event.returnValue = false;
                else{
                    event.preventDefault();
                    preventAltNumpad = true;
                }
                return;
            }
            curPos = (isIE && (obj.value.charAt(curPos - 1) == LF)) ? curPos - 2 : curPos - 1;
            if(pushMode)
                leftPushBound--;
        }
        else {
            preventDefault(event);
            return;
        }
    }
    else {
        if(pushMode)
            leftPushBound -= Math.abs(selectionStart - curPos);

            preventEraseMarker(obj);
            curPos = Math.min(selectionStart,curPos);
    }
    selectionStart = curPos;
}
///////////////////////
function processLeftarrow(obj) {
    if(curPos > fieldStart) {
        if (window.event.shiftKey) {//start selection
            if (selectionStart == curPos)
                selectionStart = curPos;

            curPos = (isIE && (obj.value.charAt(curPos - 1) == LF)) ? curPos - 2 : curPos - 1;
        }
        else {
            if(selectionStart != curPos)
                selectionStart = curPos = Math.min(selectionStart,curPos);
            else
                selectionStart = curPos = (isIE && (obj.value.charAt(curPos - 1) == LF)) ? curPos - 2 : curPos - 1;
        }
    }
    else
        preventDefault(event);
}

function processRightarrow(obj) {
    var text = obj.value;
    if(curPos < text.length) {
        if (window.event.shiftKey) {//start selection
            if (selectionStart == curPos)
                selectionStart = curPos;

            curPos = (isIE && (obj.value.charAt(curPos + 1) == LF)) ? curPos + 2 : curPos + 1;
        }
        else {
            if(selectionStart != curPos)
                selectionStart = curPos = Math.max(selectionStart,curPos);
            else
                selectionStart = curPos = (isIE && (obj.value.charAt(curPos + 1) == LF)) ? curPos + 2 : curPos + 1;
        }
    }
    else
        preventDefault(event);;
}
////////

function JSReorder()               //Visual LTR -> Logical LTR only
{
this.INIT           =  0
this.LATIN          =  1
this.LOCAL          =  2
this.NEUTRAL            =  3
this.LOCALNUMBER        =  4
this.LATINNUMBER        =  5
this.LATINNUMERICTERMINATOR =  6
this.NUMERICSEPARATOR       =  8
this.ENDOFLINE          =  9
this.CARRIAGERETURN     = 10
this.LINEFEED           = 11
this.SPACE          = 12
this.ARABICDIGIT        = 13
this.SEGMENTSEPARATOR       = 14
this.BLOCKSEPARATOR     = 15
this.BIDISPECIAL        = 16

this.LATIN_STATE        =  0
this.LOCAL_STATE        =  1
this.LATIN_NUM_STATE        =  2
this.LOCAL_NUM_STATE        =  3
this.NEUTRAL_STATE      =  4
this.EOL_STATE          =  5

this.MASK_STATE         = 0x00FF
this.MASK_ACTION        = 0xFF00

this.ACTION         = 0x4000
this.NL             = 0x4100     //NEUTRALS TO LATIN
this.NR             = 0x4200     //NEUTRALS TO LOCAL

this.LocalInvert        = 1
this.LocalNumInvert     = 2

var NL = this.NL
var NR = this.NR

this.StateTable = new Table(6,10)
this.StateTable.initTable(
                    /*  I   L   R   N   .   D   .   .   E   .*/

/* 0 LATIN_STATE     */ 0,  0,  1,  0,  -1, 2,  -1, -1, 0,  5,
/* 1 LOCAL_STATE     */ 0,  0,  1,  4,  -1, 3,  -1, -1, 4,  5,
/* 2 LATIN_NUM_STATE */ 0,  0,  1,  0,  -1, 2,  -1, -1, 0,  5,
/* 3 LOCAL_NUM_STATE */ 0,  0,  1,  4,  -1, 3,  -1, -1, 4,  5,
/* 4 NEUTRAL_STATE   */ NL|0,   NL|0,   NR|1,   4,  -1, NR|3,   -1, -1, 4,  NL|5,
/* 5 EOL_STATE       */ 0,  0,  1,  0,  -1, 2,  -1, -1, 0,  5
)
this.getStateTable = getStateTable

this.StateToClass = new Array( this.LATIN, this.LOCAL, this.LATINNUMBER, this.LOCALNUMBER,
                   this.NEUTRAL, this.ENDOFLINE )

var I               = this.INIT
var L               = this.LATIN
var R               = this.LOCAL
var D               = this.LATINNUMBER
var X               = this.LATINNUMERICTERMINATOR
var E               = this.NUMERICSEPARATOR
var N               = this.NEUTRAL
var S               = this.SPACE
var C               = this.CARRIAGERETURN
var F               = this.LINEFEED
var A               = this.ARABICDIGIT
var G               = this.SEGMENTSEPARATOR
var B               = this.BLOCKSEPARATOR
var H               = this.BIDISPECIAL

this.UnicodeTable = new Table(9,256)
this.UnicodeTable.initTable(
   /* Table 0: Unicode 00xx */
   /************************************************************************/
   /*     0   1   2   3   4   5   6   7   8   9   A   B   C   D   E   F    */
   /************************************************************************/
   /*0-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  I,  F,  N,  N,  C,  N,  N,
   /*1-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
   /*2-*/ S,  N,  N,  X,  X,  X,  N,  N,  N,  N,  N,  N,  E,  N,  E,  E,
   /*3-*/ D,  D,  D,  D,  D,  D,  D,  D,  D,  D,  E,  N,  N,  N,  N,  N,
   /*4-*/ N,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,
   /*5-*/ L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  N,  N,  N,  N,  N,
   /*6-*/ N,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,
   /*7-*/ L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  N,  N,  N,  N,  N,
   /*8-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
   /*9-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
   /*A-*/ S,  N,  X,  X,  X,  X,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
   /*B-*/ X,  X,  D,  D,  N,  N,  N,  N,  N,  D,  N,  N,  N,  N,  N,  N,
   /*C-*/ L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,
   /*D-*/ L,  L,  L,  L,  L,  L,  L,  N,  L,  L,  L,  L,  L,  L,  L,  L,
   /*E-*/ L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,
   /*F-*/ L,  L,  L,  L,  L,  L,  L,  N,  L,  L,  L,  L,  L,  L,  L,  L,

   /* Table 1: Unicode 05xx */
   /************************************************************************/
   /*     0   1   2   3   4   5   6   7   8   9   A   B   C   D   E   F    */
   /************************************************************************/
   /*0-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
   /*1-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
   /*2-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
   /*3-*/ N,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,
   /*4-*/ L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,
   /*5-*/ L,  L,  L,  L,  L,  L,  L,  N,  N,  L,  L,  L,  L,  L,  L,  L,
   /*6-*/ N,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,
   /*7-*/ L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,
   /*8-*/ L,  L,  L,  L,  L,  L,  L,  L,  N,  L,  N,  N,  N,  N,  N,  N,
   /*9-*/ N,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,
   /*A-*/ R,  R,  N,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,
   /*B-*/ R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  N,  R,  R,  R,  R,  R,
   /*C-*/ R,  R,  R,  R,  R,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
   /*D-*/ R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,
   /*E-*/ R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  N,  N,  N,  N,  N,
   /*F-*/ R,  R,  R,  R,  R,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,

   /* Table 2: Unicode 06xx */
   /************************************************************************/
   /*     0   1   2   3   4   5   6   7   8   9   A   B   C   D   E   F    */
   /************************************************************************/
   /*0-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  R,  N,  N,  N,
   /*1-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  R,  N,  N,  N,  N,
   /*2-*/ N,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,
   /*3-*/ R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  N,  N,  N,  N,  N,
   /*4-*/ R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,
   /*5-*/ R,  R,  R,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
   /*6-*/ A,  A,  A,  A,  A,  A,  A,  A,  A,  A,  X,  A,  A,  R,  N,  N,
   /*7-*/ R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,
   /*8-*/ R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,
   /*9-*/ R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,
   /*A-*/ R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,
   /*B-*/ R,  R,  R,  R,  R,  R,  R,  R,  N,  N,  R,  R,  R,  R,  R,  N,
   /*C-*/ R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  N,
   /*D-*/ R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,
   /*E-*/ R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  N,  N,
   /*F-*/ D,  D,  D,  D,  D,  D,  D,  D,  D,  D,  N,  N,  N,  N,  N,  N,

   /* Table 3: Unicode 20xx */
   /************************************************************************/
   /*     0   1   2   3   4   5   6   7   8   9   A   B   C   D   E   F    */
   /************************************************************************/
   /*0-*/ S,  S,  S,  S,  S,  S,  S,  E,  S,  S,  S,  S,  N,  N,  L,  R,
   /*1-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
   /*2-*/ N,  N,  N,  N,  N,  N,  N,  N,  B,  B,  H,  N,  N,  N,  H,  N,
   /*3-*/ X,  X,  X,  X,  X,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
   /*4-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
   /*5-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
   /*6-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  H,  H,  H,  H,
   /*7-*/ D,  N,  N,  N,  D,  D,  D,  D,  D,  D,  X,  X,  N,  N,  N,  N,
   /*8-*/ D,  D,  D,  D,  D,  D,  D,  D,  D,  D,  X,  X,  N,  N,  N,  N,
   /*9-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
   /*A-*/ X,  X,  X,  X,  X,  X,  X,  X,  X,  X,  X,  X,  N,  N,  N,  N,
   /*B-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
   /*C-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
   /*D-*/ L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,
   /*E-*/ L,  L,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
   /*F-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,

   /* Table 4: Unicode 21xx */
   /************************************************************************/
   /*     0   1   2   3   4   5   6   7   8   9   A   B   C   D   E   F    */
   /************************************************************************/
   /*0-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
   /*1-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
   /*2-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
   /*3-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
   /*4-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
   /*5-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
   /*6-*/ L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,
   /*7-*/ L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,
   /*8-*/ L,  L,  L,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
   /*9-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
   /*A-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
   /*B-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
   /*C-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
   /*D-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
   /*E-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
   /*F-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,

   /* Table 5: Unicode 30xx */
   /************************************************************************/
   /*     0   1   2   3   4   5   6   7   8   9   A   B   C   D   E   F    */
   /************************************************************************/
   /*0-*/ S,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
   /*1-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
   /*2-*/ N,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,
   /*3-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
   /*4-*/ N,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,
   /*5-*/ L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,
   /*6-*/ L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,
   /*7-*/ L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,
   /*8-*/ L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,
   /*9-*/ L,  L,  L,  L,  L,  N,  N,  N,  N,  L,  L,  L,  L,  L,  L,  N,
   /*A-*/ N,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,
   /*B-*/ L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,
   /*C-*/ L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,
   /*D-*/ L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,
   /*E-*/ L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,
   /*F-*/ L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  N,

   /* Table 6: Unicode FBxx */
   /************************************************************************/
   /*     0   1   2   3   4   5   6   7   8   9   A   B   C   D   E   F    */
   /************************************************************************/
   /*0-*/ L,  L,  L,  L,  L,  L,  L,  N,  N,  N,  N,  N,  N,  N,  N,  N,
   /*1-*/ N,  N,  N,  L,  L,  L,  L,  L,  N,  N,  N,  N,  N,  N,  R,  R,
   /*2-*/ R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,
   /*3-*/ R,  R,  R,  R,  R,  R,  R,  N,  R,  R,  R,  R,  R,  N,  R,  N,
   /*4-*/ R,  R,  N,  R,  R,  N,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,
   /*5-*/ R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,
   /*6-*/ R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,
   /*7-*/ R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,
   /*8-*/ R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,
   /*9-*/ R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,
   /*A-*/ R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,
   /*B-*/ R,  R,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
   /*C-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
   /*D-*/ N,  N,  N,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,
   /*E-*/ R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,
   /*F-*/ R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,

   /* Table 7: Unicode FExx */
   /************************************************************************/
   /*     0   1   2   3   4   5   6   7   8   9   A   B   C   D   E   F    */
   /************************************************************************/
   /*0-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
   /*1-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
   /*2-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
   /*3-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
   /*4-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
   /*5-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
   /*6-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
   /*7-*/ R,  R,  R,  N,  R,  N,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,
   /*8-*/ R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,
   /*9-*/ R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,
   /*A-*/ R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,
   /*B-*/ R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,
   /*C-*/ R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,
   /*D-*/ R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,
   /*E-*/ R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,
   /*F-*/ R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  N,  N,  N,

   /* Table 8: Unicode FFxx */
   /************************************************************************/
   /*     0   1   2   3   4   5   6   7   8   9   A   B   C   D   E   F    */
   /************************************************************************/
   /*0-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
   /*1-*/ D,  D,  D,  D,  D,  D,  D,  D,  D,  D,  N,  N,  N,  N,  N,  N,
   /*2-*/ N,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,
   /*3-*/ L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  N,  N,  N,  N,  N,
   /*4-*/ N,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,
   /*5-*/ L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  N,  N,  N,  N,  N,
   /*6-*/ N,  N,  N,  N,  N,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,
   /*7-*/ L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,
   /*8-*/ L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,
   /*9-*/ L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,
   /*A-*/ L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,
   /*B-*/ L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  N,
   /*C-*/ N,  N,  L,  L,  L,  L,  L,  L,  N,  N,  L,  L,  L,  L,  L,  L,
   /*D-*/ N,  N,  L,  L,  L,  L,  L,  L,  N,  N,  L,  L,  L,  N,  N,  N,
   /*E-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
   /*F-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N
)
this.getUnicodeTable = getUnicodeTable

this.stringAsClasses = new Array()
this.terminatorFlag = 0

this.doReorder = doReorder
this.stringToClass = stringToClass
this.applyClass = applyClass
this.getCharClass = getCharClass
this.getCharacterType = getCharacterType
this.doAction = doAction
this.invertSegment = invertSegment
this.needInvert = needInvert
this.doSymSwap = doSymSwap
}

function getStateTable()
{
   return this.StateTable
}

function getUnicodeTable()
{
   return this.UnicodeTable
}

function getCharacterType(ch)
{
    var utab = this.getUnicodeTable().getArray()
    var str = new String(ch)
    var code = str.charCodeAt(0)
    var index = (code & 0xFF00) >> 8
    switch (index)
    {
        case 0x00: break
        case 0x05: index = 1
               break
        case 0x06: index = 2
               break
        case 0x20: index = 3
               break
        case 0x21: index = 4
               break
        case 0x30: index = 5
               break
        case 0xFB: index = 6
               break
        case 0xFE: index = 7
               break
        case 0xFF: index = 8
               break
      default:   return(this.NEUTRAL)
    }
    return (utab[index][code & 0xFF])
}

function doReorder(str)
{
    if (str == null || str.length < 2)
        return (str)
    this.stringToClass(str)
    return (this.applyClass(str))
}

function stringToClass(str)
{
    var stab = this.getStateTable().getArray()
    var prevState = 0
    var initialCharClass = this.LATIN
    var curState = stab[prevState][initialCharClass]
    var curCharClass
    var i

    for (i=0; i<str.length; i++)
    {
        prevState = curState
        curCharClass = this.getCharClass(str,i)
        curState = stab[prevState][curCharClass]
        this.stringAsClasses[i] = this.StateToClass[curState & this.MASK_STATE] | this.terminatorFlag
        this.doAction(curState,i)
        curState &= this.MASK_STATE
    }

    for (i=0; i<str.length; i++)
        if ((this.stringAsClasses[i] & this.MASK_ACTION) == this.ACTION)
            this.stringAsClasses[i] &= this.MASK_STATE
}

function getCharClass(str,index)
{
    var prev = this.NEUTRAL
    var next = this.NEUTRAL
    var curr
    var result

    this.terminatorFlag = 0
    if (index > 0)
        prev = this.getCharacterType(str.charAt(index-1))
    curr = this.getCharacterType(str.charAt(index))

    switch (curr)
    {
        case this.BLOCKSEPARATOR:
        case this.SEGMENTSEPARATOR:
            result = this.LATIN
            break
        case this.ARABICDIGIT:
            result = this.LATINNUMBER
            break
        case this.LATINNUMERICTERMINATOR:
            if (index>0)
                prev = this.stringAsClasses[index-1]
            if (prev == this.LATINNUMBER || prev == this.LOCALNUMBER)
                result = this.LATINNUMBER
            else
            {
                this.terminatorFlag = this.ACTION
                result = this.NEUTRAL
            }
            break
        case this.NUMERICSEPARATOR:
            result = this.NEUTRAL
            if (prev == this.LATINNUMBER)
            {
                if (index < str.length - 1)
                    next = this.getCharacterType(str.charAt(index+1))
                switch (next)
                {
                    case this.LATINNUMBER:
                        result = next
                        break
                    case this.LOCAL:
                    case this.NEUTRAL:
                        result = curr
                        break
                }
            }
            break
        case this.BIDISPECIAL:
        case this.SPACE:
            result = this.NEUTRAL
            break
        case this.CARRIAGERETURN:
        case this.LINEFEED:
            result = this.ENDOFLINE
            break
        default:
            result = curr
    }
    return (result)
}

function doAction(currState,index)
{
    var action = currState & this.MASK_ACTION
    var classFromAction

    switch (action)
    {
        case this.NL:
        case this.NR:
            classFromAction = (action & this.MASK_ACTION & ~this.ACTION) >> 8
            while (index-- > 0)
            {
                if ((this.stringAsClasses[index] & this.MASK_STATE) == this.NEUTRAL)
                {
                    if ((this.stringAsClasses[index] & this.MASK_ACTION) &&
                        (this.stringAsClasses[index+1] == this.LOCALNUMBER ||
                         this.stringAsClasses[index+1] == this.LATINNUMBER))
                        this.stringAsClasses[index] = this.stringAsClasses[index+1]
                    else
                        this.stringAsClasses[index] = classFromAction
                }
                else
                    break
            }
            break
    }
}

function applyClass(str)
{
    var array = new Array(str.length)
    var Str = new String("");
    var i
    for (i=0; i<str.length; i++)
        array[i] = str.charAt(i)
    this.invertSegment(array,this.LocalNumInvert)
    this.invertSegment(array,this.LocalInvert)
    for (i=0; i<array.length; i++)
        Str += array[i]
    return (Str)
}

function needInvert(invertType,index)
{
    switch (invertType)
    {
        case this.LocalInvert:
            return (this.stringAsClasses[index] == this.LOCAL ||
                    this.stringAsClasses[index] == this.LOCALNUMBER)
        case this.LocalNumInvert:
            return (this.stringAsClasses[index] == this.LOCALNUMBER)
        default:
            return (false)
    }
}

function invertSegment(s,invertType)
{
    var start = 0
    var end
    var sum
    var tmp
    var i

    while (start < s.length)
    {
        if (this.needInvert(invertType,start))
        {
            end = start + 1
            while (end < s.length)
            {
                if (!this.needInvert(invertType,end))
                    break
                end++
            }
            sum = end - 1 + start
            for (; start < sum - start; start++)
            {
                tmp = this.doSymSwap( s[start] )
                s[start] = this.doSymSwap( s[sum-start] )
                s[sum-start] = tmp
            }
            start = end - 1
        }
        start++
    }
}

// --------------------------------------------------------

function Table(nrows,ncols)
{
    var i = 0
    this.trows = nrows
    this.tcols = ncols
    this.rows = new Array(nrows)
    for (i=0; i<nrows; i++)
        this.rows[i] = new Array(ncols)
    this.initTable = initTable
    this.getArray = getArray
}

function getArray()
{
    return this.rows
}

function initTable()
{
    var i = 0
    var j = 0
    var k = 0
    var l = 0
    var m = Math.min(this.trows*this.tcols,initTable.arguments.length)
    for (k=0; k<m; k++,l++)
    {
        if (l == this.tcols)
        {
            i++
            j=0
            l=0
        }
        this.rows[i][j++] = this.initTable.arguments[k]
    }
}
