/*
 * Licensed Materials - Property of IBM
 *
 * Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA DP Schedule Contract with IBM Corp.
 */

egl.lastFunctionEntered = "???";
egl.elements = [];
egl.widgets = [];
egl.listeners = [];
egl.jobs = [];
egl.eze$$userLibs = [];

window.onunload = function() {
	try { egl.terminateSession(); } catch (e) {}
}

egl.crashTerminateSession = function(){
	if (egl.IE) {
		egl.commonTerminateSession();
		for (var n=0; n<egl.widgets.length; n++)
			if (egl.widgets[n] != egl.Document.body)
				egl.widgets[n].eze$$DOMElement = null;
		
	}
};

egl.terminateSession = function(){
	if (egl.IE) {
		egl.commonTerminateSession();
		for (var i = egl.elements.length - 1; i >= 0; i--) {
			var e = egl.elements[i];
			e.style.visibility = "hidden";
			document.body.appendChild(e);
		}
		for (var n=0; n<egl.widgets.length; n++)
			if (egl.widgets[n] != egl.Document.body)
				egl.widgets[n].eze$$DOMElement = null;
		for (f in egl) egl[f]=null;
	}
};

egl.commonTerminateSession = function() {
	egl.sessionIsValid = false;
	for (var n=0; n<egl.listeners.length; n++)
		egl.removeEventListener(egl.listeners[n].element, egl.listeners[n].type, egl.listeners[n].handler);
	for (var i = egl.elements.length - 1; i >= 0; i--)
		try { egl.elements[i].eze$$widget.destroy(); } catch (e) { }
};

egl.LRO = String.fromCharCode(8237);
egl.RLO = String.fromCharCode(8238);
egl.LRE = String.fromCharCode(8234);
egl.RLE = String.fromCharCode(8235);
egl.PDF = String.fromCharCode(8236);

egl.contextRoot = window.egl__contextRoot;
egl.enableSelection = false;
egl.console = null;
egl.canPrintToConsole = true;
egl.Document = null;
// context key to be assigned from the sever to the browser
egl.contextKey = "";
//
egl.workStartTime = new Date().getTime();

egl.core = function() {};
egl.core.ServiceKind = {
		EGL : 		1,
		WEB : 		2,
		NATIVE : 	3,		
		REST : 		4
};

egl.ui = function() {};
egl.ui.SignKind = {
		LEADING : 	1,
		NONE : 		2,
		PARENS : 	3,
		TRAILING : 	4
};

egl.IE = (window.navigator.userAgent.indexOf("MSIE ") >= 0);
egl.IPhone = !egl.IE && (window.navigator.userAgent.indexOf("iPhone") >= 0);
egl.Firefox = !egl.IE && (window.navigator.userAgent.indexOf("Firefox") >= 0);
egl.XulRunner = !egl.Firefox && (window.navigator.userAgent.indexOf("Gecko") >= 0);
egl.Opera = !egl.Firefox && (window.navigator.userAgent.indexOf("Opera") >= 0);
egl.Chrome = !egl.Opera && (window.navigator.userAgent.indexOf("Chrome") >= 0);

egl.SECS_PER_DAY = 86400;
egl.MS_PER_DAY = 86400000;
egl.US_PER_DAY = 86400000000;
egl.MS_PER_MINUTE = 60000;
//egl.SECS_BETWEEN_1900_1970 = 25568 * egl.SECS_PER_DAY;
egl.DEFAULT_DATE_VALUE_MS = -25568 * egl.MS_PER_DAY;
egl.DEFAULT_DATE_VALUE_US = -25568 * egl.US_PER_DAY;

egl.autoConvertMessages = true;

egl.tzOffsetSec = function(d) {
	d = d || new Date();
	return d.getTimezoneOffset()/*min*/ * 60;
};
egl.tzOffsetMS = function(d) {
	return egl.tzOffsetSec(d) * 1000;
};

if (!Array.prototype.forEach) {
	Array.prototype.forEach = function(f) {
		for (var n=0; n<this.length; n++) {
			f(this[n]);
		}
	};
}

egl.ruiHandlers = [];

egl.print = function(s) {
	if(egl.canPrintToConsole){
		if (egl.console === null) {
			egl.console = egl.createChild(document.body, "tt");
			egl.console.innerHTML = "<hr>";
			egl.console.onmouseover = function (e) {
				egl.consoleCurrentSelectionMode = egl.enableSelection;
				egl.setEnableTextSelection(true);
			}
			egl.console.onmouseout = function (e) {
				egl.setEnableTextSelection(egl.consoleCurrentSelectionMode);
			}

		}
		var span = egl.createChild(egl.console, "span");
		span.innerHTML = s;
	}
};

egl.println = function(s) {
	egl.print(s);
	egl.print("<br>");
	egl.checkWork();
};

if (egl.canPrintToConsole) {
	setInterval(function() {
		if (egl.console && egl.console.nextSibling) {
			document.body.removeChild(egl.console);
			document.body.appendChild(egl.console);
		}
	}, 1000);
}

egl.parseInt = function(s) {
	try {
		var result = parseInt(s.replace(/px/g,""));
		return isNaN(result) ? 0 : result;
	}
	catch (e) {
		return 0;
	}
};

egl.cachedWidget = null;

egl.getWidgetAt = function(x, y, ignoreElement) {
	if (egl.cachedWidget) {
		egl.cachedWidget = egl.getWidgetAtCrawl(x, y, egl.cachedWidget.eze$$DOMElement.parentNode, ignoreElement);
	}
	if (!egl.cachedWidget) {
		egl.cachedWidget = egl.getWidgetAtCrawl(x, y, document.body, ignoreElement);
	}
	return egl.cachedWidget;
};

egl.getWidgetAtCrawl = function(x, y, element, ignoreElement) {
	if (!element || element == ignoreElement || element.offsetTop == undefined) {
		return null;
	}
	var eX = egl.getX(element);
	var eY = egl.getY(element);
	var eWidth = egl.getWidthInPixels(element);
	var eHeight = egl.getHeightInPixels(element);
	if (x < eX || x > eX + eWidth || y < eY || y > eY + eHeight) {
		return null;
	}
	for (var child = element.firstChild; child; child = child.nextSibling) {
		if (child.style && child.style.visibility != "hidden") {
			var widget = egl.getWidgetAtCrawl(x, y, child, ignoreElement);
			if (widget) return widget;
		}
	}
	return (element.eze$$widget);
};

egl.createWidget = function(domElement) {
	if (domElement.eze$$widget)
		return domElement.elg$$widget;
	var result = new egl.egl.ui.rui.Widget();
	result.eze$$DOMElement = domElement;
	result.eze$$isSynthetic = true;
	return result;		
};

egl.createChild = function(parent, tagName) {
	var child = egl.createElement(tagName);
	parent.appendChild(child);
	return child;
};

egl.createElement = function(tagName) {
	var element;
	if (egl.IE) {
		element = document.createElement('<'+tagName+'>');
	}
	else {
		if (tagName.indexOf(" ") != -1)
		{
			var tag = tagName.substring(0, tagName.indexOf(" "));
			element = document.createElement(tag);
			var subStr = tagName.substring(tagName.indexOf(" ") + 1, tagName.length);
			while (subStr.length >= 1)
			{
				var arg = subStr.substring(0,subStr.indexOf("="));
				subStr = subStr.substring(subStr.indexOf("=") + 1, subStr.length);
				var nextStop = subStr.indexOf(" ") == -1 ? subStr.length : subStr.indexOf(" ");
				var value = subStr.substring(0, nextStop);
				subStr = subStr.substring(nextStop + 1, subStr.length);
				
				arg.trim();
				value.trim();				
				
				element.setAttribute(arg, value);
			}
		}
		else
			element = document.createElement(tagName);
	}
	if(egl.IE){
		egl.elements.push(element);
	}
	return element;
};

egl.getX = function(element){
	return egl.getClientX(element);
};

egl.getY = function(element){
	return egl.getClientY(element);
};

egl.getBorderLeftWidth = function(element) {
	var style = element.currentStyle || element.style;
	var w = egl.parseInt(style.borderLeftWidth);
	if (w === 0 && style.borderStyle && style.borderStyle != "none") {w = 4;}
	if (w !== 0 && (!style.borderStyle || style.borderStyle == "none")) {w = 0;}
	return w;
};

egl.getClientX = function(element){
	var x = 0;
	try {
		x = -egl.getBorderLeftWidth(element);
	    while (element && element.offsetParent) {
	        x += element.offsetLeft + egl.getBorderLeftWidth(element);
	        element = element.offsetParent;
	    }
	}
	catch (e) {
	}
    return x;
};

egl.getBorderTopWidth = function(element) {
	var style = element.currentStyle || element.style;
	var w = egl.parseInt(style.borderTopWidth);
	if (w === 0 && style.borderStyle && style.borderStyle != "none") {w = 4;}
	if (w !== 0 && (!style.borderStyle || style.borderStyle == "none")) {w = 0;}
	return w;
};

egl.getClientY = function(element){
    var y = 0;
	try {
		y = -egl.getBorderLeftWidth(element);
	    while (element && element.offsetParent){
	        y += element.offsetTop + egl.getBorderTopWidth(element);
	        element = element.offsetParent;
	    }
 	}
	catch (e) {
	}
    return y;
};

egl.toPX = function(num) {
	if (num == "" || isNaN(Number(num))) return num;
	return num + "px";
}

egl.setX = function(element, x) {
    if (element) {
    	try {
    		if (x.prototype != Number.prototype) x = new Number(x);
    		if (document.layers) element.left = egl.toPX(x); else element.style.left = egl.toPX(x);
    	}
    	catch (e) {
    		throw egl.createRuntimeException( "CRRUI1001E", [ e.message, element.tagName+".x", x ] );
    	}
	}
};

egl.setY = function(element, y) {
	if (element) {
		try {
	    	if (y.prototype != Number.prototype) y = new Number(y);
			if (document.layers) element.top = egl.toPX(y); else element.style.top = egl.toPX(y);
    	}
    	catch (e) {
    		throw egl.createRuntimeException( "CRRUI1001E", [ e.message, element.tagName+".y", y ] );
    	}
	}
};

egl.getWidth = function(element){
	if (!egl.getStyle(element)) return;
	return egl.getStyle(element).width;
};

egl.getHeight = function(element){
	if (!egl.getStyle(element)) return;
	return egl.getStyle(element).height;
};

egl.getWidthInPixels = function(element){
	if (!element) return;
	
	var w = ("" + egl.getWidth(element)).toUpperCase();
	if( w.substr(w.length-2) == "PX" )
	{
		w = w.substr(0, w.length-2);
	}
	
	if (w != "" && !isNaN(w))
		return w;
	
	if (!element.offsetWidth || isNaN(element.offsetWidth))
	{
		return element.clientWidth;
	}
	else
	{
		return element.offsetWidth;
	}
};

egl.getHeightInPixels = function(element){
	if (!element) return;
	
	var h = ("" + egl.getHeight(element)).toUpperCase();
	if ( h.substr(h.length-2) == "PX" )
	{
		h = h.substr(0, h.length-2);
	}

	if (h != "" && !isNaN(h))
		return h;
	
	if (!element.offsetHeight || isNaN(element.offsetHeight))
	{
		return element.clientHeight;
	}
	else
	{
		return element.offsetHeight;
	}
};

egl.setWidth = function(element, w) {
	try {
		if (element && element.style) {
	        if (element.tagName === "TD" || element.tagName === "IMG")
	            element.width = w;
	        else {
	        	if (typeof(w) == "number") { 
	        		w = Math.max(0, w);
	        	}
	        }
            element.style.width = w;
		}
	}
	catch (e) {
		throw egl.createRuntimeException( "CRRUI1001E", [ e.message, element.tagName+".width", w ] );
	}

};

egl.setHeight = function(element, h) {
    try {
    	if (element) {
	        if (element.tagName === "TD" || element.tagName === "IMG")
	            element.height = h;
	        else {
	        	if (typeof(h) == "number") { 
	        		h = Math.max(0, h);
	        	}
	        }
            element.style.height = h;
	    }
	}
	catch (e) {
		throw egl.createRuntimeException( "CRRUI1001E", [ e.message, element.tagName+".height", h ] );
	}

};

egl.toJSONString = function(object, depth, maxDepth) {
	try {
		if (depth == undefined) {
			depth = 0;
			maxDepth = 13;
		}
		if (maxDepth && depth > maxDepth) {
			return '" Max Recursion '+maxDepth+' reached"';
		}
		if (object && object.toJSONString) {
			return object.toJSONString();
		}
		if (typeof(object) == "string") {
			return '"' + egl.convertStringToJson(object) + '"';
		}
		if (typeof(object) == "number") {
			return String(object);
		}
		if (typeof(object) == "boolean") {
			return Boolean(object);
		}
		if (object instanceof Date) {
		   var sig = object.eze$$signature;
		   if (sig != null) {
		       var kind = sig.charAt(0) === '?' ? sig.charAt(1) : sig.charAt(0);
		   }
		   if (kind == 'K') {
		     return '"' + egl.egl.core.$StrLib.formatDate(object, egl.egl.core.$StrLib.isoDateFormat) + '"';
		   }
		   else if (kind == 'L') {
		     return '"' + egl.egl.core.$StrLib.formatTime(object, "HH:mm:ss") + '"';
		   }
		   return '"' + egl.egl.core.$StrLib.formatTimeStamp( object, egl.formatTimeStampPattern("yyyyMMddHHmmss")) + '"' ;
		}
		if (object instanceof egl.javascript.BigDecimal) {
			return object.toString();
		}
		if (!object || (object instanceof egl.egl.jsrt.Record && object.eze$$isNull)) {
			return "null";
		}
		if (object.eze$$InParamSignatures) {
		    egl.setDateSignatures(object);
		}    
		if (object instanceof egl.egl.jsrt.Record || object instanceof egl.egl.Dictionary) {
			egl.setDateSignatures(object);
		}
		if (object.length || object.maxSize == 2147483647) {
			if (object.getType()) {
		        egl.setDateSignatures(object);
			}
			try {
				var s = [];
				s.push("[");
				var needComma = false;
				for (var n=0; n<object.length; n++) {
					if (typeof(object[n]) != 'function') {
						if (needComma) s.push(",");
						s.push(egl.toJSONString(object[n], depth+1, maxDepth));
						needComma = true;
					}
				}
				s.push("]");
				return s.join('');
			}
			catch (e) {
			}
		}
		var s = [];
		s.push("{");
		var needComma = false;
		for (f in object) {
			if (!f.match(/^eze\$\$/) && (typeof object[f] != "function")) {
				if (needComma) s.push(",");
				s.push('"');
				var key = f;
				if (object instanceof egl.egl.jsrt.Record) {
					key = object.eze$$getJSONName(key);
				}
				s.push(key);
				s.push('":');
				s.push(egl.toJSONString(egl.unboxAny( object[f] ), depth+1, maxDepth));
				needComma = true;
			}
		}
		s.push("}");
		return s.join('');
	}
	catch (e) {
		return '"Cannot toJSONString '+object+' due to '+e+'"';
	}
};


egl.toXMLString = function(namespaces, xmlName, object, depth, maxDepth) {
	if (object == undefined || object === null) {
		return "";
	}
	
	var s = [];
	try {
		if (depth == undefined) {
			depth = 0;
			maxDepth = 13;
		}
		if (maxDepth && depth > maxDepth) {
			s.push("Max Recursion "+maxDepth+" reached");
		}
		else if (object instanceof Array) {
			if (object.getType()) {
		        egl.setDateSignatures(object);
			}
			for (var n=0; n<object.length; n++) {
				if (typeof(object[n]) != 'function') {
					s.push(egl.toXMLString(namespaces, xmlName, object[n], depth+1, maxDepth));
				}
			}
		}
		else if (object.eze$$toXML) {
			s.push(object.eze$$toXML(namespaces, xmlName, object, depth+1, maxDepth));
		}
		else {
			s.push("<" + xmlName + ">");
			
			if (typeof(object) == "string") {
				s.push(egl.convertStringToJson(object));
			}
			else if (typeof(object) == "number") {
				s.push(String(object));
			}
			else if (typeof(object) == "boolean") {
				s.push(Boolean(object));
			}
			else if (object instanceof Date) {
				var sig = object.eze$$signature;
				if (sig != null) {
					var kind = sig.charAt(0) === '?' ? sig.charAt(1) : sig.charAt(0);
				}
				if (kind == 'K') {
					s.push(egl.egl.core.$StrLib.formatDate(object, egl.egl.core.$StrLib.isoDateFormat));
				}
				else if (kind == 'L') {
					s.push(egl.egl.core.$StrLib.formatTime(object, "HH:mm:ss"));
				}
				else
					s.push(egl.egl.core.$StrLib.formatTimeStamp( object, egl.formatTimeStampPattern("yyyyMMddHHmmss")));
			}
			else if (object instanceof egl.javascript.BigDecimal) {
				s.push(object.toString());
			}
			else {
				for (f in object) {
					if (!f.match(/^eze\$\$/) && (typeof object[f] != "function")) {
						s.push(egl.toXMLString(namespaces, f, egl.unboxAny( object[f] ), depth+1, maxDepth));
					}
				}
			}
			s.push("</" + xmlName + ">");
		}
	}
	catch (e) {
		return '"Cannot toXMLString '+object+' due to '+e+'"';
	}
	return s.join('');
};

egl.convertStringToJson = function(value) {
	var str = value;
	str = str.replace(/\\/g, "\\\\");     // escape all \'s (e.g. \ -> \\)
	str = str.replace(/"/g, "\\\"");  	  // escape all "'s (e.g. " -> \")
	str = str.replace(/\//g, "\\/");	  // escape all /'s (e.g. / -> \/)
	str = str.replace(/[\b]/g, "\\b");	  // escape all <backspace> 
	str = str.replace(/\r/g, "\\r");	  // escape all <return>
	str = str.replace(/\t/g, "\\t");	  // escape all <tab>
	str = str.replace(/\f/g, "\\f");	  // escape all <formfeed>
	str = str.replace(/\n/g, "\\n");	  // escape all <newline>
	return str;	
};

egl.setDateSignatures = function(object) {
    if (object instanceof egl.egl.jsrt.Record) {
        var sig = object.eze$$getFieldSignatures();
        for (var n = 0; n < sig.length; n++) {
           if (sig[n].value instanceof Date) {
               sig[n].value.eze$$signature = sig[n].type;
           }
        }
        return;    
    }
    if (object.eze$$InParamSignatures) { 
        // service IN parameters
        var sig = object.eze$$InParamSignatures;
        for (var n = 0; n < sig.length; n++) {
           if (object.params[n] instanceof Date) {
               object.params[n].eze$$signature = sig[n];
           }
        } 
        return;    
    }
    if (object instanceof Array) { 
    	var sig = egl.inferSignature(object);
	    var kind = sig.charAt(1) === '?' ? sig.charAt(2) : sig.charAt(1);
	    if (kind == 'K' || kind == 'L' || kind == 'J') {
	       for (var n = 0; n < object.length; n++) {
	           if (object[n]) {
			       object[n].eze$$signature = kind;
			   }
		   }
		}
		return;
    }
	if (object instanceof egl.egl.Dictionary) {
		for (f in object) {
			if (!f.match(/^eze\$\$/) && (typeof object[f] != "function")) {
			   var sig = object[f].eze$$signature;
			   var kind = sig.charAt(0) === '?' ? sig.charAt(1) : sig.charAt(0);
			   if (kind == 'K' || kind == 'L' || kind == 'J') {
			       object[f].eze$$value.eze$$signature = object[f].eze$$signature;
			   }
			}
		} 
		return;   
    }
};

egl.printError = function( ) { }

egl.eze$$packages = { };

egl.makePackage = function( /*String*/ pkgname ) {
	//handle case for default (empty) EGL package
	if (pkgname === "") {
		return egl;
	}	
	var elems = pkgname.split( '.' );
	if (elems.length < 1) return;
	var pkg = egl;
	for ( var n=0; n < elems.length; n++ ) {
		var elem = elems[ n ];
		if ( !pkg[ elem ] ) {
			pkg[ elem ] = {};
		}
		pkg = pkg[ elem ];
	}	
	egl.eze$$packages[pkgname] = pkg;
	return pkg;
};

egl.setClassFunctions = function(/*Class*/ clazz, /*function[]*/ functions) {
	for (name in functions) {
		functions[name].definingClass = clazz.prototype;
		clazz.prototype[name] = functions[name];
	}
};

egl._defineClass = function(
		/*String*/ packageName,
		/*String*/ className
		// OPTIONAL String superPackageName,
		// OPTIONAL String superClassName,
		// object[] functions
		// trace flag
		) {
	try {
		if (arguments.length == 4) {
			var functions = arguments[2];
			var traceFlag = arguments[3];
		} else {
			var superPackageName = arguments[2];
			var superClassName = arguments[3];
			var functions = arguments[4];
			var traceFlag = arguments[5];
		}
		
		var pkg = egl.makePackage( packageName );
		if ( pkg[className] ) {	return; }
		
		var superclazz;
		
		var clazz = function( ) {
			if (superclazz) {
				superclazz.apply(this, arguments);
			}	
			if (functions.constructor) {
				try {
					functions.constructor.apply( this, arguments );
				}
				catch (e) {
					egl.printError(egl.getRuntimeMessage( "CRRUI2082E", [className]), e);
					throw e;
				}
			}
			this.toString = function() {
				try {
					var dataOutput = "type=" + this.eze$$package + "." + this.eze$$typename;
					if ( this.eze$$DOMElemnt )
					    dataOutput = dataOutput + ", tagName=" + this.eze$$DOMElement.tagName + ",childCount=" + this.eze$$DOMElement.childNodes.length ; 
                    if ( this instanceof egl.egl.core.AnyException )
                        dataOutput = dataOutput + ", message=" + this.message;	
                    return "[" + dataOutput + "]";				    		    
				}
				catch (e) {
					return "["+className+"]";
				}
			};
		}
		
		pkg[className] = clazz;
		if (superPackageName) {
			var spkg = egl.makePackage(superPackageName);
			if (!spkg || !spkg[superClassName] ) return;			
			superclazz = spkg[superClassName];
			clazz.prototype = new superclazz();
			clazz.prototype.eze$$superClass = superclazz;
		}

		clazz.prototype.eze$$thisClass = clazz;
		clazz.prototype.eze$$package = packageName;
		clazz.prototype.eze$$typename = className;	
		clazz.prototype.eze$$signature = 
				"T" + packageName.toLowerCase().replace(/\./g,"/") + 
				"/" + className.toLowerCase() + ";";
					
		egl.setClassFunctions(clazz, functions, 
			traceFlag //internal classes not defined by the user?
		);
	}
	catch (e) {
		egl.printError(egl.getRuntimeMessage( "CRRUI2083E", [className]), e);
	}
};

egl.defineClass = function(
	/*String*/ packageName,
	/*String*/ className
	// OPTIONAL String superPackageName,
	// OPTIONAL String superClassName,
	// object[] functions
	) {
	var a = new Array();
	for (var i=0;i<arguments.length;i++) a.push(arguments[i]);
	a.push(true); //internal - no tracing
	egl._defineClass.apply(this,a);
};

egl.defineRUILibrary = function(
	/*String*/ packageName,
	/*String*/ className
	// OPTIONAL String superPackageName,
	// OPTIONAL String superClassName,
	// object[] functions
	) {
	var a = new Array();
	for (var i=0;i<arguments.length;i++) a.push(arguments[i]);
	a.push(false); //user defined - enable tracing
	egl._defineClass.apply(this,a);
};

egl.defineRUIPropertiesLibrary = function(
	/*String*/ packageName,
	/*String*/ className,
	/*String*/ propertiesFile,
	/*function[]*/ functions
	) {
	try {
		var pkg = egl.makePackage( packageName );
		if ( pkg[className] ) {	return; }
		var superPkg = egl.makePackage( 'egl.ui.rui' );
		var superClassName = 'RUIPropertiesLibrary';
		var clazz = function( derivedClazz ) {
			superPkg[superClassName].call( this, derivedClazz );
			functions.constructor.call( this );	
			this.eze$$initializeProperties(propertiesFile);
		}	
		clazz.prototype = new superPkg[superClassName]( clazz );
		pkg[className] = clazz;
		clazz.prototype.eze$$superClass = superPkg[superClassName];	
		clazz.prototype.eze$$thisClass = clazz;	
		clazz.prototype.egl$isWidget = false;
		clazz.prototype.eze$$package = packageName;
		clazz.prototype.eze$$typename = className;
		clazz.prototype.eze$$signature = 
				"T" + packageName.toLowerCase().replace(/\./g,"/") + 
				"/" + className.toLowerCase() + ";";
		egl.setClassFunctions(clazz, functions, 
			true    // these are internal classes not defined by the user
		);
	}
	catch (e) {
		egl.printError(egl.getRuntimeMessage( "CRRUI2084E", [packageName, className]), e);
	}
};

egl.startVEWidgetTimer = function() {
	if (egl.enableEditing && egl.contextAware && egl.getWidgetPositions && !egl.getWidgetPositionsTimer) {
		egl.getWidgetPositionsTimer = setTimeout(function() { 
			egl.getWidgetPositions(); 
			egl.getWidgetPositionsTimer = null;
		}, 1);
	}
};

egl.defineWidget = function(
			/*String*/   packageName,
			/*String*/   className,
			/*String*/   superPackageName,
			/*String*/   superClassName,
			/*String*/   domElementTypeName,
			/*function[]*/ functions) {
	try {
		var pkg = egl.makePackage( packageName );
		if ( pkg[className] ) {	return; }
		var superPkg = egl.makePackage( superPackageName );
		var clazz = function( derivedClazz ) {
			superPkg[superClassName].call( this, derivedClazz );
			if( !derivedClazz ){
				this.createeze$$DOMElement();
			}	
			functions.constructor.call( this );	
			egl.startVEWidgetTimer();
		}	
		clazz.prototype = new superPkg[superClassName]( clazz );
		clazz.prototype.createeze$$DOMElement = function(){
			if(this.eze$$DOMElement){return};
			this.eze$$DOMElement = egl.createElement( domElementTypeName );
			this.eze$$DOMElement.eze$$widget = this;
			if(egl.IE){
				egl.widgets.push(this);
			}
			this.eze$$initializeDOMElement();
		}
		pkg[className] = clazz;
		clazz.prototype.eze$$superClass = superPkg[superClassName];	
		clazz.prototype.eze$$thisClass = clazz;	
		clazz.prototype.egl$isWidget = true;
		clazz.prototype.eze$$package = packageName;
		clazz.prototype.eze$$typename = className;
		clazz.prototype.eze$$signature = 
				"T" + packageName.toLowerCase().replace(/\./g,"/") + 
				"/" + className.toLowerCase() + ";";
		egl.setClassFunctions(clazz, functions, 
			true    // these are internal classes not defined by the user
		);
		clazz.prototype.eze$$initializeDOMElement = function(){
			// call the super
			if(superPkg[superClassName].prototype.eze$$initializeDOMElement){
				superPkg[superClassName].prototype.eze$$initializeDOMElement.call( this );
			}
			
			if(functions.eze$$initializeDOMElement){
				functions.eze$$initializeDOMElement.call( this );
			}
		}
		if (egl.instrumentFunctions)
			egl.instrumentFunctions(className, clazz.prototype);
	}
	catch (e) {
		egl.printError(egl.getRuntimeMessage( "CRRUI2085E", [packageName, className, superPackageName, superClassName]), e);
	}
};

// Don't notify parent widgets
egl.stopEventPropagation = function(e){
	e = e || window.event;
   	e.cancelBubble = true;
	e.returnValue = false;
   	if (e.stopPropagation) e.stopPropagation();
};

egl.getButton = function(e){
	if (e.which)  return e.which;
	if (e.button) return e.button;
	return 0;
};

egl.defineRUIHandler = function(/*String*/   packageName, 
								/*String*/   className, 
								/*function[]*/ functions) {
	try {
		egl.enter("Internal error while defining RUIHandler "+packageName+"."+className);
		var pkg = egl.makePackage( packageName );
		if ( pkg[className] ) {	return; }
		var spkg = egl.makePackage('egl.ui.rui');
		if (!spkg || !spkg.View ) return;
		var superclazz = spkg.View;
		var clazz = function( derivedClazz ) {
			superclazz.call( this, derivedClazz );
			try{
				egl.enter("<init>", this, arguments);
				egl.ruiHandlers[ egl.ruiHandlers.length ] = this;
				//Call routine to instantiate class variables
				functions.constructor.call( this );
				
				document.body.style.marginLeft = 0;
				document.body.style.marginTop = 0;
			}
			finally{
				egl.leave();
			}
		}		
		pkg[className] = clazz;	
		clazz.prototype = new superclazz( clazz );
		clazz.prototype.eze$$superClass = superclazz;
		clazz.prototype.eze$$thisClass = clazz;
		clazz.prototype.eze$$package = packageName;
		clazz.prototype.eze$$typename = className;	
		clazz.prototype.eze$$signature = 
			"T" + packageName.toLowerCase().replace(/\./g,"/") + 
			"/" + className.toLowerCase() + ";";
		egl.setClassFunctions(clazz, functions,
			false   // these are user-defined functions
		);
	}
	catch (e) {
		egl.printError(egl.getRuntimeMessage( "CRRUI2086E", [className]), e);
	}
	finally {
		egl.leave();
	}
};

egl.defineRUIWidget = function (/*String*/   packageName, 
		/*String*/   className, 
		/*function[]*/ functions,
		/*String*/ tagName){
	try {
		egl.enter("Internal error while defining RUIWidget "+packageName+"."+className);
		var pkg = egl.makePackage( packageName );
		if ( pkg[className] ) {	return; }
		var spkg = egl.makePackage('egl.ui.rui');
		if (!spkg || !spkg.Widget ) {
			throw egl.createRuntimeException( "CRRUI1030E", ['egl.ui.rui', 'Widget'] );
		}
		var superclazz = spkg.Widget;
		
		var clazz = function( derivedClazz ) {
			try{
				egl.enter("<init>", this, arguments);
				superclazz.call( this );
				if (tagName)
					this.setTagName(tagName);
				this.toString = function() {
					try {
						return "[type="+this.eze$$package+"."+this.eze$$typename+",tagName="+this.eze$$DOMElement.tagName+",childCount="+this.eze$$DOMElement.childNodes.length+"]";
					}
					catch (e) {
						return "["+className+"]";
					}
				};
				functions.constructor.call( this );
				if (this.targetWidget)
					this.eze$$becomeTarget(egl.unboxAny(this.targetWidget));
				this.setClass("EglRui" + className);
				this.eze$$initializeDOMElement();
				egl.startVEWidgetTimer();
			}
			finally {
				egl.leave();
			}
		}
		pkg[className] = clazz;	
		
		clazz.prototype = new superclazz( clazz );
		clazz.prototype.eze$$thisClass = clazz;
		clazz.prototype.eze$$package = packageName;
		clazz.prototype.eze$$typename = className;	
		clazz.prototype.eze$$signature = 
				"T" + packageName.toLowerCase().replace(/\./g,"/") + 
				"/" + className.toLowerCase() + ";";
		egl.setClassFunctions(clazz, functions,
			false   // these are user-defined functions
		);
	}
	catch (e) {
		egl.printError(egl.getRuntimeMessage( "CRRUI2087E", [className]), e);
	}
	finally {
		egl.leave();
	}
};

egl.setEnableTextSelection = function(value) {
    egl.enableSelection = value;
    document.body.style.unselectable = value ? "off" : "on";
    document.body.style.MozUserSelect = value ? "text" : "none";
};

document.onselectstart = function(e) { 
	return egl.enableSelection;
};

egl.setEnableTextSelection(false);

egl.onLoadReady = function(f) {
	var p = window.onload;
	if (typeof window.onload != 'function') {
		window.onload = f;
	} else {
		window.onload = function() {
			if (p) { p(); }
			f();
		}
	}
};

egl.stopPropagation = function() { this.cancelBubble = true; };
egl.preventDefault = function() { this.returnValue = false; };
egl.getEventX = function() { 
	var element = document.body;
	try { element = this.widget.eze$$DOMElement; } catch (e) { }; 
	return (this.clientX || 0) - egl.getX(element); 
};
egl.getEventY = function() { 
	var element = document.body;
	try { element = this.widget.eze$$DOMElement; } catch (e) { }; 
	return (this.clientY || 0) - egl.getY(element); 
};

egl.wrapEvent = function(e, target) {
	e = e || window.event;
	var element = e.srcElement || e.target;
	if (target) {
		e.widget = target;
		element = target.eze$$DOMElement;
	}
	else {
		while (element && !element.eze$$widget)
			element=element.parentNode;
		if (element)
			e.widget = element.eze$$widget;
	}
	e.stopPropagation =	e.stopPropagation || egl.stopPropagation;
	e.preventDefault = e.preventDefault || egl.preventDefault;
	e.getX = egl.getEventX;
	e.getY = egl.getEventY;
	e.ch = e.keyCode || e.charCode || 0;
	e.mouseButton = e.which ? e.which : 0;
	if (e.screenX == null) e.screenX = 0;
	if (e.screenY == null) e.screenY = 0;
	if (e.clientX == null) e.clientX = 0;
	if (e.clientY == null) e.clientY = 0;
	switch (e.button) {
		case 1:
			e.mouseButton = 1;
			break;
		case 4:
			e.mouseButton = 2;
			break;
		case 2:
		case 3:
			e.mouseButton = 3;
			break;
	}
	e.stopPropagation();
	return e;
}

egl.addEventListener = function(
		/*DOMelem*/ elem,
		/*String*/ evtype,
		/*function*/ listener,
		/*object*/ thisObj) {
	
	var handler = function(e) { 
		e = egl.wrapEvent(e, thisObj);
		try {
			if(!egl.debugg) egl.debugStack = [ {functionName: "Event "+evtype, fileName: "Browser", lineNumber: "0" }];
			listener.call(thisObj, e);
			if (egl.IE) {
				try { document.fireEvent("on"+e.type, e); } catch (e) { }
			}
			else {
				eval('try { document.on'+e.type+'(e); } catch (e) { }');
			}
		}
		catch (ee) {
			if (egl.egl.debug && ee instanceof egl.egl.debug.DebugTermination){
				if (ee.msg) egl.println(ee.msg);
			}
			else {
				egl.printError(egl.getRuntimeMessage( "CRRUI1083E", [e.type]), ee);
			}
		}
		finally {
			if (!egl.debugg) egl.leave();
		}
		return true; //shensis I change this since return false blocks the execution of any event handler in IE;
	};
	if ( elem.addEventListener ) {
		// Mozilla, Netscape, FireFox, etc
		elem.addEventListener( evtype, handler, false );
		egl.listeners.push( { element: elem, type: 'on'+evtype, handler: handler });	
		return true;
	}
	if ( !elem.attachEvent ) {
		// primitive or nonstandard browser
		elem[ 'on' + evtype ] = handler;
		return true;
	}
	var ret = elem.attachEvent( 'on' + evtype, handler );
	egl.listeners.push( { element: elem, type: 'on'+evtype, handler: handler });	
	return ret;
};


egl.removeEventListener = function(element, type, listener) {
	if (element.removeEventListener) 
		element.removeEventListener(type, listener, false); 
	else if (element.detachEvent) 
		element.detachEvent('on'+type, listener); 
};

if (typeof (XMLHttpRequest) != "undefined") {
	egl.newXMLHttpRequest = function() {
			return new XMLHttpRequest();
		};
		}
else if (window.ActiveXObject) {
	try {
		new ActiveXObject( "Msxml2.XMLHTTP" ); 
		egl.newXMLHttpRequest = function() {
			return new ActiveXObject( "Msxml2.XMLHTTP" );
		}
	}
	catch( e ) {
		try {
			new ActiveXObject( "Microsoft.XMLHTTP" ); 
			egl.newXMLHttpRequest = function() {
				return new ActiveXObject( "Microsoft.XMLHTTP" );
	 		}
	 	}
		catch (e) {
		}
	}
};
if (!egl.newXMLHttpRequest) {
	egl.printError(egl.getRuntimeMessage( "CRRUI2088E", []), null)	
};

egl.makePackage('egl.rui');

egl.defineClass(
	'egl.core', 'MathLib',
{
	"constructor" : function() {
		if (egl.egl.core.$MathLib) return egl.egl.core.$MathLib;
		egl.egl.core.$MathLib=this;
	},
	"cosh" : function( /* hyperbolic angle */ x ) {
		return ( ( Math.exp( x ) + Math.exp( -x ) ) / 2 );
	},
	"frexp" : function( y, x, assignFunc ) {
		if ( y > 0 ) {
			x = Math.floor( Math.log( y ) / Math.log( 2 ) ) + 1;
		} else if ( y < 0 ) {
			x = Math.floor( Math.log( Math.abs( y ) ) / Math.log( 2 ) ) + 1;
		} else {
			x = 0;
		}
		
		if (assignFunc) {
			assignFunc(x);
		}
		return y * Math.pow( 2, -x );
	},
	"log" : function( /*float*/ x ) {
		if ( x > 0 ) {
			return Math.log( x );
		} else {
			throw egl.createRuntimeException( "CRRUI2038E", ["MathLib.log"] );
		}
	},
	"log10" : function( /*float*/ x ) {
		if ( x > 0 ) {
			return Math.LOG10E * Math.log(x);
		} else {
			throw egl.createRuntimeException( "CRRUI2038E", ["MathLib.log10"] );
		}
	},
	"modf" : function(/*float*/ num, /*int*/ intPart, assignFunc ) {
		var deciPart;
		var isBigDecimal = ( intPart instanceof egl.javascript.BigDecimal );
		
		if ( parseInt( num ) == num ) {
			intPart = num;
			deciPart = 0;
		} else {
			var numStr = new String( num );
			intPart = Number( numStr.replace( /\.\d*/, "" ) );
			deciPart = Number( numStr.replace( /\d*\./, "0." ) );
		}
		
		if ( isBigDecimal ) {
			//this does the assignment, since BigDecimal is an object
			intPart = new egl.javascript.BigDecimal( intPart.toString() );
		}
		
		if (assignFunc) {
			assignFunc(intPart);
		}
		return deciPart;
	},
	"pow" : function( /*float*/ base, /*float*/ exp ) {
		if ( base == 0 && exp <= 0 ) {
			throw egl.createRuntimeException( "CRRUI2040E", ["MathLib.pow"] );
		} else if ( base < 0 && parseInt( exp ) != parseFloat( exp ) ) {
			throw egl.createRuntimeException( "CRRUI2041E", ["MathLib.pow"] );
		} else {
			return Math.pow( base, exp );
		}
	},
	"sinh" : function( /* hyperbolic angle */ x ) {
		return ( ( Math.exp( x ) - Math.exp( -x ) ) / 2 );
	},
	"sqrt" : function( /*float*/ x ) {
		if ( x >= 0 ) {
			return Math.sqrt(x);
		} else {
			throw egl.createRuntimeException( "CRRUI2039E", ["MathLib.sqrt"] );
		}
	},
	"tanh" : function( /* hyperbolic angle */ x ) {
		return ( ( Math.exp( 2 * x ) -  1) / (Math.exp( 2 * x ) + 1 ) );
	},
	"round" : function( /* value */ v, /* exp */ e ) {
		var rounder;
		if ( e > 0 ) {
			rounder = 5.0 * Math.pow(10, e - 1 );
		} else {
			rounder = 5.0 / Math.pow(10, -e + 1 );
		}

		if ( v >= 0 ) {
			v = v + rounder;
		} else {
			v = v - rounder;
		}

		if ( e > 0 ) {
			v = v / Math.pow(10, e );
			v = parseInt( v );
			v = v * Math.pow(10, e );
		} else {
			v = v * Math.pow(10, -e );
			v = parseInt( v );
			v = v / Math.pow(10, -e );
		}

		return v;
	},
	"stringAsInt" : function( /* value */ v ) {
		try {
			if (v == "") {
				return null;
			}
			return egl.convertStringToBigint(v);
		}
		catch (e) {
			return null;
		}
	},
	"stringAsFloat" : function( /* value */ v ) {
		try {
			if (v == "") {
				return null;
			}
			return egl.convertStringToFloat(v);
		}
		catch (e) {
			return null;
		}
	},
	"stringAsDecimal" : function( /* value */ v ) {
		try {
			var bd = new egl.javascript.BigDecimal(v);
			if (bd.movePointRight(bd.scale()).abs().toString().length > 32) {
				return null;
			}
			return bd;
		}
		catch (e) {
			return null;
		}
	},
	"eze$$getChildVariables": function() {
		return [];
	}
});

egl.xmllib_xsi_url = "http://www.w3.org/2001/XMLSchema-instance";
egl.defineClass(
    'egl.core', 'XMLLib',
{
	"constructor" : function() {
		if (egl.egl.core.$XMLLib) return egl.egl.core.$XMLLib;
		egl.egl.core.$XMLLib=this;
	},
	"convertFromXML" : function(/*String*/ xml, /*any*/ rec) {
		if (typeof(xml) != "string") {
			throw egl.createRuntimeException("CRRUI2030E", typeof(xml));
		}
		xml = egl.trim(xml);
		var dom = null;
		try {
			if (egl.Firefox || egl.XulRunner || egl.Opera) { 
				dom = (new DOMParser()).parseFromString(xml, "application/xml"); 
			} 
			else {
				if (egl.IE) { 
					dom = new ActiveXObject("MSXML2.DOMDocument");
					dom.loadXML(xml); 
				}
			}
		}
		catch(e) {
			throw egl.createRuntimeException("CRRUI2031E", e);
	    }
	    rec.eze$$fromXML(dom.documentElement);	
	},
	"convertToXML" : function(/*any*/ rec) {
		// top level records get there name from their XML root values
		var namespaces = {};
		namespaces.xmlns_map = {};
		namespaces.count = 0;
	    var xml = rec.eze$$toXML( namespaces, null );  // top level records
	    return this.addNamespacesToXML( namespaces, xml );
	},
	"getChildElements" : function(/*DOM Element*/element) {
		var children = element.childNodes;
		var elements = {};
		// loop through the immediate child elements looking for matches (2+ matches is an array)
		for ( var n=0; n < children.length; n++ ) {
			// test to see if child is an element node
			if (children[ n ].nodeType == 1) {	
				var pairsArray = children[ n ].tagName.split(':'); // IE doesn't support localName
				var localName = pairsArray[pairsArray.length-1];
				if (!elements[localName]) {
					elements[localName] = [];
				}
				elements[localName][elements[localName].length] = children[ n ];
			}
		}		
		var nodelists = [];
		var i = 0;
		for (f in elements) {
			nodelists[i] = elements[f];
			i++;
		}
		return nodelists;
	},
	"getChildElement" : function(/*DOM Element*/element, /*string*/name) {
		return getChildElementNS(element, name, null);
	},
	"getChildElementNS" : function(/*DOM Element*/element, /*string*/name, /*string*/namespace) {
		namespace = (!namespace)?this.defaultNamespace():namespace;
		
		var children = element.childNodes;
		var elements = [];
		var i = 0;
		// loop through the immediate child elements looking for matches (2+ matches is an array)
		for ( var n=0; n < children.length; n++ ) {
			// test to see if child is an element node
			if (children[ n ].nodeType == 1) {	
				var pairsArray = children[ n ].tagName.split(':'); // IE doesn't support localName
				var localName = pairsArray[pairsArray.length-1];
				if (localName == name && children[ n ].namespaceURI == namespace) {
					elements[ i ] = children[ n ];
					i++;
				}					
			}
		}		
		return elements;
	},
	"setSimpleElementField" : function(/*DOM Element*/element, /*string*/name, /*string*/namespace) {
		var nodelist = this.getChildElementNS( element, name, namespace );
		if (nodelist.length > 0)
			return this.getElementText( nodelist[0] );
		else
			return null;		
		
	},
	"setRecordElementField" : function(/*DOM Element*/element, /*Record*/ rec, /*string*/name, /*string*/namespace) {
		var nodelist = this.getChildElementNS( element, name, namespace );
		if (nodelist.length > 0) {
			rec.eze$$isNull = false;
			rec.eze$$fromXML( nodelist[ 0 ], name);
		}	
		else {
			rec.eze$$isNull = true;
		}
	},
	"setDictionaryElementField" : function(/*DOM Element*/element, /*Dictionary*/ dictionary, /*string*/name, /*string*/namespace) {
		var nodelist = this.getChildElementNS( element, name, namespace );
		if (nodelist.length > 0) {
			dictionary.eze$$fromXML( nodelist[ 0 ], name);
		}
		return dictionary;
	},
	"getAttribute" : function(/*DOM Element*/element, /*string*/name, /*string*/namespace) {
		return getAttributeNS( element, name, null );
	},
	"getAttributeNS" : function(/*DOM Element*/element, /*string*/name, /*string*/namespace) {
		namespace = (!namespace)?this.defaultNamespace():namespace;
		
		var attrs = element.attributes;
		if (attrs != null) {
		   // loop through attributes
		   for (var i=0; i < attrs.length; i++) {
			   var attr = attrs.item(i);
			   var pairsArray = attr.name.split(':'); // IE doesn't support localName
			   var localName = pairsArray[pairsArray.length-1];
			   if(localName == name && attr.namespaceURI == namespace) {
					return attr.value;
			   }
           }	
		}
		return null;
	},
	"getElementText" : function(element) {
		var children = element.childNodes;
		var texts = [];
		var i = 0;
		for ( var n=0; n < children.length; n++ ) {
			if (children[ n ].nodeType == 3) {
			  	  texts[ i ] = children[ n ].nodeValue;
			  	  i++;
			}
		}		
		return texts.join('');
	},
	"getElementTyped" : function(element) {
		var text = this.getElementText(element);
		var value = text;
		var ltext = text.toLowerCase();
		if ("true" == ltext || "false" == ltext) {
			value = Boolean("true" == ltext);
		}
		else
		{
			var type = this.determineType(text);
			var any = egl.boxAny(text, "S;");
			value = egl.convertAnyToType(any, type);
		}
		return value;
	},
	"determineType": function(/*string*/ text) {
		text = text.trim();
		var isNumeric = true;
		var isFloat = false;
		var isDecimal = false;
		for (var i=0; i < text.length; i++)
		{
			var c = text.charAt(i);
			if (c == '.')
			{
				if (isDecimal) // more than one
				{
					isNumeric = false;
					break;
				}
				isDecimal = true;
			}
			else if (c == '+' || c == '-'){
				
			}
			else if (c == 'e' || c == 'E')
			{
				if (isFloat) // more than one
				{
					isNumeric = false;
					break;
				}
				isFloat = true;
			}
			else if ( c < '0' || c > '9') // not numeric
			{
				isNumeric = false;
				break;
			}
		}
		var type = "S;";
		if (isNumeric)
		{
			if (isFloat)
			{
    			type = "F;";
    		}
    		else if (isDecimal)
    		{
    			var bd = new egl.javascript.BigDecimal(text);
    			var decimals = bd.scale() < 0? 0: bd.scale();
    			type = "d32:" + decimals + ";";
    		}
    		else
    		{
    			type = "I;";
    		}
    	}
    	return type;
	},
	"addNamespace": function(namespaces, namespace) {
		if (namespaces.xmlns_map[namespace])
			return namespaces.xmlns_map[namespace] + ":";
		
		namespaces.count++;
		var prefix = "ns"+namespaces.count;
		namespaces.xmlns_map[namespace] = prefix;
		return prefix + ":";
	},
	"addXSINamespace": function(namespaces) {
		namespaces.xmlns_map[egl.xmllib_xsi_url] = "xsi";
	},
	"addNamespacesToXML": function(namespaces, xml) {
		var s = [];
		for(f in namespaces.xmlns_map) {
			s.push(" xmlns:"+namespaces.xmlns_map[f]+"=\""+f+"\"");
		}
		
		var ndx = xml.indexOf(">"); 
		return xml.substring(0,ndx) + s.join('') + xml.substring(ndx);
	},
	"writeAttribute": function(field, xmlName, dateType) {
		var attrName = xmlName;
		var fieldValue = field;
		if (field instanceof egl.javascript.BigDecimal)
			fieldValue = field.toString();
		if (dateType) {
		   if (dateType == 'K') {
		     fieldValue = egl.egl.core.$StrLib.formatDate(field, egl.egl.core.$StrLib.isoDateFormat);
		   }
		   else if (dateType == 'L') {
		     fieldValue = egl.egl.core.$StrLib.formatTime(field, "HH:mm:ss");
		   } 
		   else if (dateType == "J") {
		     fieldValue = egl.egl.core.$StrLib.formatTimeStamp( field, egl.formatTimeStampPattern("yyyyMMddHHmmss")); 		
		   }
		}
		return " " + attrName + "=\"" + fieldValue + "\"";
	},
	"writeElement": function(field, xmlName, dateType) {
		var tagName = xmlName;
		var fieldValue = field;
		if (field instanceof egl.javascript.BigDecimal) {
			fieldValue = field.toString();	
	    }
		if (dateType) {
		   if (dateType == 'K') {
		     fieldValue = egl.egl.core.$StrLib.formatDate(field, egl.egl.core.$StrLib.isoDateFormat);
		   }
		   else if (dateType == 'L') {
		     fieldValue = egl.egl.core.$StrLib.formatTime(field, "HH:mm:ss");
		   } 
		   else if (dateType == "J") {
		     fieldValue = egl.egl.core.$StrLib.formatTimeStamp( field, egl.formatTimeStampPattern("yyyyMMddHHmmss")); 		
		   }
		}
		return "<" + tagName + ">" + fieldValue + "</" + tagName + ">";
	},
	"writeElementValue": function(field, xmlName, dateType) {
		var fieldValue = field;
		if (field instanceof egl.javascript.BigDecimal) {
			fieldValue = field.toString();	
	    }
		if (dateType) {
		   if (dateType == 'K') {
		     fieldValue = egl.egl.core.$StrLib.formatDate(field, egl.egl.core.$StrLib.isoDateFormat);
		   }
		   else if (dateType == 'L') {
		     fieldValue = egl.egl.core.$StrLib.formatTime(field, "HH:mm:ss");
		   } 
		   else if (dateType == "J") {
		     fieldValue = egl.egl.core.$StrLib.formatTimeStamp( field, egl.formatTimeStampPattern("yyyyMMddHHmmss")); 		
		   }
		}
		return fieldValue;
	},
	"defaultNamespace": function() {
		if (egl.IE) {
			return "";
		}
		else {
			return null;
		}
	},
	"eze$$getChildVariables": function() {
		return [];
	}
});
egl.defineClass(
	'egl.core', 'ServiceLib',
{
	"constructor" : function() {				
		if (egl.egl.core.$ServiceLib) return egl.egl.core.$ServiceLib;
		egl.egl.core.$ServiceLib=this;	
		egl.egl.core.ServiceLib.$inst = this;
		/**
		 * static fields,
		 * holds the response information for the last service invocation made
		 */
 		this.callBackResponse = new egl.egl.core.HttpResponse();
 		
 		/**
 		 * system variable, delegate for the default service exception callback function
 		 */
 		this.serviceExceptionHandler = new egl.egl.jsrt.Delegate(egl.egl.core.$ServiceLib, egl.egl.core.ServiceLib.prototype.serviceExceptionCallback);
 		
 		//holds the userid and password info for proxy authentication		
        this.eze$$proxyUser = "";
        this.eze$$proxyPwd = "";
 		
 		this.base64keyStr = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
	},
	"base64encode" : function (input) {
		var output = "";
		var chr1, chr2, chr3, enc1, enc2, enc3, enc4;
		var i = 0;
		
		input = this.utf8Encode(input);
		while (i < input.length) {
			chr1 = input.charCodeAt(i++);
			chr2 = input.charCodeAt(i++);
			chr3 = input.charCodeAt(i++);

			enc1 = chr1 >> 2;
			enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
			enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
			enc4 = chr3 & 63;

			//use = to pad
			if (isNaN(chr2)) {
				enc3 = enc4 = 64;
			}
			else if (isNaN(chr3)) {
				enc4 = 64;
			}

			output = output + this.base64keyStr.charAt(enc1) + this.base64keyStr.charAt(enc2) +
							  this.base64keyStr.charAt(enc3) + this.base64keyStr.charAt(enc4);
		}
		return output;
	},	
	"utf8Encode" : function (inStr) {
		inStr = inStr.replace(/\r\n/g,"\n");
		var utftext = "";
		for (var i = 0; i < inStr.length; i++) {
			var c = inStr.charCodeAt(i);
			if (c < 128) {
				utftext += String.fromCharCode(c);
			}
			else if((c > 127) && (c < 2048)) {	//2 bytes
				utftext += String.fromCharCode((c >> 6) | 192);
				utftext += String.fromCharCode((c & 63) | 128);
			}
			else {								//3 bytes
				utftext += String.fromCharCode((c >> 12) | 224);
				utftext += String.fromCharCode(((c >> 6) & 63) | 128);
				utftext += String.fromCharCode((c & 63) | 128);
			}
			//browser does not support any unicode that's 4 bytes or more
		}
		return utftext;
	},	
    "checkURLEncode" : function (/*String*/ stringIn){
    	if(stringIn.length > 0){
    		var lowercaseStr = stringIn.toLowerCase();
    		//if starts with http, do not url encode it
    		if(lowercaseStr.indexOf("http") != 0){
    			return egl.egl.core.$ServiceLib.convertToURLEncoded(stringIn);
    		}
    	}
    	return stringIn;
    },	
	"convertFromURLEncoded" : function(/*String*/ urlEncoded) {
		return decodeURIComponent( urlEncoded );
	}, 
	"convertToURLEncoded" : function(/*String*/ eglType){
		return encodeURIComponent( eglType );
	},
	"convertToJSON" : function(/*recordOrDictionary*/ object) {
			return egl.toJSONString(object);
	},
	"convertFromJSON" : function( /*String*/ str, /*recordOrDictionary*/ recordOrDictionary, /*boolean*/ordered ) {
		if (/^(\[|{)/.test(str)) {
			try {
				var object = egl.egl.jsrt.$JSONParser.parse( str );
				if (!recordOrDictionary) // if recordOrDictionary is null then the function returns a Javascript object
				{
					return object;
				}
				else  // else this is record or dictionary
				{
					recordOrDictionary.eze$$fromJson( object, ordered );
					return recordOrDictionary;
				}
			}
			catch (e) {
				str = str.replace(/&/g,"&amp;").replace(/</g,"&lt;");
				throw egl.createRuntimeException( "CRRUI2089E", [str, e.message] );
			}
		}
		return null;
	},
	"throwExceptionIfNecessary" : function(/*Object*/ object, /*String*/ fieldName, /*boolean*/ isNullable ) {
		if(object === undefined) {
		   throw egl.createRuntimeException("CRRUI2105E", [fieldName]);
		}
		
		if (isNullable == false && object === null) {
		   throw egl.createRuntimeException("CRRUI2106E", [fieldName]);
		}	
	},
	"convertObjectToDictionary" : function(/*Object*/ object, /*Dictionary*/ dictionary) {
		for(f in object) {
			if (typeof object[f] == "object")
			{ 
				if ( object[f] instanceof Array )
				{
					egl.valueByKey(dictionary, f, object[f], egl.inferSignature(object[f]));
				}
				else 
				{
					var dict = egl.createDictionary(true, false);
					dict.eze$$fromJson( object[f] );
					egl.valueByKey(dictionary, f, dict, "y;");
				}
			}
			else
			{
				egl.valueByKey(dictionary, f, object[f], egl.inferSignature(object[f]));	
			}
		}
	},
    "convertToFormData" : function (/*Object*/ obj){
        var formdata="";
        var needAnd = false;
        for(f in obj){
            if (!f.match(/^eze\$\$/) && (typeof obj[f] != "function")) {
                if(needAnd) 
                    formdata += '&';
                var key = egl.egl.core.$ServiceLib.convertToURLEncoded(obj.eze$$getFORMName(f));        //encode key
                var value = egl.egl.core.$ServiceLib.convertToURLEncoded(obj[f]); //encode value
                formdata += key;
                formdata += '=';
                formdata += value;
                needAnd = true;
            }
        }                    
        return formdata;
    },
    "convertFromFormData" : function (/*String*/ str){
    	var formdataObj = null;
    	var pairsArray = str.split('&');
    	for(var i=0; i<pairsArray.length; i++){
    		var pair = parisArray[i].split('=');
    		var key = egl.egl.core.$ServiceLib.convertFromURLEncoded(pair[0]);
    		var val = egl.egl.core.$ServiceLib.convertFromURLEncoded(pair[1]);
    		formdataObj.key = val;
    	}
    	return formdataObj;
    },	    
    "setRestRequestHeaders" : function(/*RESTServiceRefWrapper*/ serviceWrapper, /*Dictionary*/ reqHeaders){
    	var restRequestHeader = this.getRestRequestHeaders(serviceWrapper);
    	
    	//copy the key/value from the reqHeaders to the serviceWrapper's rest request header
    	var keys = egl.getKeys(reqHeaders);    	
        for (var i=0; i<keys.length; i++) {
        	var value = egl.findByKey(reqHeaders, keys[i]);
        	egl.valueByKey(restRequestHeader, keys[i], value.eze$$value, value.eze$$signature);		
        }    	
    },
    "setHTTPBasicAuthentication" : function(/*ServiceRefWrapper*/ serviceWrapper, /*String*/usr, /*String*/ pwd){
    	var reqHeaders = this.getRestRequestHeaders(serviceWrapper);    	
    	if(serviceWrapper.f_type == "web"){
    		egl.valueByKey(reqHeaders, "egl_user", this.base64encode(usr), "S;");
    		egl.valueByKey(reqHeaders, "egl_pwd", this.base64encode(pwd), "S;");
    	}
    	else if(serviceWrapper.f_type == "rest"){
	    	var usrNpwd = usr + ":" + pwd;
	    	var base64encodedVal = this.base64encode(usrNpwd);
	    	var value = "Basic " +  base64encodedVal;
	    	egl.valueByKey(reqHeaders, "Authorization", value, "S;");
    	}
    },
    "setProxyBasicAuthentication" : function(/*String*/ usr, /*String*/ pwd){
        this.eze$$proxyUser = usr;
        this.eze$$proxyPwd = pwd;        
    	egl.eze$$SetProxyAuth = true;
    },
    "getRestRequestHeaders" : function(/*RESTServiceRefWrapper*/ serviceWrapper){
    	return serviceWrapper.getRESTRequestHeader();
    },
    "getCurrentCallbackResponse" :function(){
    	return this.callBackResponse;
    },
    "getOriginalRequest": function(){
    	var jsonObj = this.convertFromJSON(this.callBackResponse.originalRequest);
    	var requestObj = new egl.egl.core.HttpRequest();
    	requestObj.eze$$fromJson(jsonObj);
    	return requestObj;
    },
    "getWebServiceLocation" : function(/*ServiceRefWrapper*/ serviceWrapper){
    	if(serviceWrapper.f_type == "web")
    		return serviceWrapper.f_wsdlUri;
    	else
    		throw egl.createServiceBindingException("CRRUI3652E", [serviceWrapper.f_type, "web"]);	//wrong binding type
    },
    "setWebServiceLocation" : function(/*ServiceRefWrapper*/ serviceWrapper, /*String*/ newURI){
       	if(serviceWrapper.f_type == "web")
       		serviceWrapper.f_wsdlUri = newURI || "";
       	else
       		throw egl.createServiceBindingException("CRRUI3652E", [serviceWrapper.f_type, "web"]);	//wrong binding type
    },
    "getRestServiceLocation" : function(/*ServiceRefWrapper*/ serviceWrapper){
    	if(serviceWrapper.f_type == "rest")
    		return serviceWrapper.f_baseURI;
    	else
    		throw egl.createServiceBindingException("CRRUI3652E", [serviceWrapper.f_type, "rest"]);	//wrong binding type
    },
    "endStatefulServiceSession" : function(/*ServiceRefWrapper*/ serviceWrapper, /*func*/ errCallback){
    	if(serviceWrapper.f_type == "rest"){
    		//use the default error handler if none is passed in as param
    		var theErrCallback = errCallback || egl.egl.core.$ServiceLib.serviceExceptionHandler;
    		serviceWrapper.invokeEGLService(null, null, theErrCallback, "eze_endStatefulServiceSession", [], [], []);
    	}
    	else
    		throw egl.createServiceInvocationException("CRRUI3652E", [serviceWrapper.f_type, "rest"]);	//wrong binding type
    },
    "setRestServiceLocation" : function(/*ServiceRefWrapper*/ serviceWrapper, /*String*/ newBaseURI){
    	if(serviceWrapper.f_type == "rest")    	
    		serviceWrapper.f_baseURI = newBaseURI || "";
    	else
    		throw egl.createServiceBindingException("CRRUI3652E", [serviceWrapper.f_type, "rest"]);	//wrong binding type    	
    },
    "bindService": function(/*String*/ eglddName, /*String*/bindingKeyName){
    	var binding = egl.egl.jsrt.$ServiceBinder.getBinding(eglddName, bindingKeyName);
   		return binding.createServiceWrapper();	
    },
    "serviceExceptionCallback" : function( /*Tegl/core/AnyException;*/ exp ) {
    	var headerMsg = "";
    	var bodyMsg = "";    	
    	try{
	    	var reqObj = egl.egl.core.$ServiceLib.getOriginalRequest();    	
	    	var isJSONRPC = egl.egl.jsrt.$ServiceRT.isJsonRPCFormat(reqObj);
	    	
	    	if(reqObj){
		    	headerMsg = reqObj.uri;
		    	bodyMsg = reqObj.body;
		    	if(isJSONRPC==true){
		    		//the body is in json format
		    		var d = egl.createDictionary(false, false);
		    		if(bodyMsg != null && bodyMsg != ""){
			    		egl.egl.core.$ServiceLib.convertFromJSON( bodyMsg, d ); 
			    		var methodName = (egl.unboxAny(egl.valueByKey(d, "method"))).toString();
						headerMsg += " on method: " + methodName;
		    		}
		    	}
		    	//else    		//the body could be in xml, string, formdata...
	    	}
    	}
    	catch(e){
    		egl.println("Exception occurred while parsing the original request.");
    		egl.println(e.message);
    	}
    	
 		egl.println( " " );
		egl.println( "An exception has occurred while calling " + headerMsg);
		egl.println( "The body of the request was: " + bodyMsg);
		egl.println( "message:" + exp.message );
		if ( exp instanceof egl.egl.core.ServiceInvocationException ) {
			var serviceKind = egl.egl.core.$ServiceLib.serviceKind(exp);
			egl.println( "ServiceKind:" + serviceKind );
			egl.println( "detail1:" + exp.detail1 );
			egl.println( "detail2:" + exp.detail2 );
			egl.println( "detail3:" + exp.detail3.replace(/&/g, "&amp;").replace(/</g,"&lt;").replace(/>/g, "&gt;"));
		}
		return;
	},
	"serviceKind": function( /*Tegl/core/ServiceInvocationException;*/ sie ) {
		var $result = "";
		switch( sie.source ) {
			case egl.core.ServiceKind.WEB:
				$result = "WEB";
				return $result;
				break;
			case egl.core.ServiceKind.NATIVE:
				$result = "NATIVE";
				return $result;
				break;
			case egl.core.ServiceKind.EGL:
				$result = "EGL";
				return $result;
				break;
			case egl.core.ServiceKind.REST:
				$result = "REST";
				return $result;
				break;
			default:
				$result = "unknown";
				return $result;
				break;
		}
		return $result;
	},
    "eze$$getChildVariables": function() {
		return [];
	}
});

egl.getStyle = function(element) {
	return element.currentStyle || element.style;
};

egl.keepTrying = function(testFunction, actionFunction, delay) {
	function doit() {
		if (testFunction()) {
			actionFunction();
		}
		else {
			setTimeout(function() { 
				doit(); 
			}, delay);
		}
	}
	doit();
};

egl.toString = function(object) {
	try {
		if (typeof(object) == "string") {
			return '<font color=blue>"' + object + '"</font>';
		}
		if (typeof(object) == "number") {
			return String(object);
		}
		if (typeof(object) == "boolean") {
			return Boolean(object);
		}
		if (typeof(object) == "function") {
			return "function";
		}
		if (!object) {
			return "null";
		}
		if (object.tagName) {
			return object.tagName;
		}
		if (object.length) {
			try {
				var s = [];
				s.push("[");
				var needComma;
				for (var n=0; n<object.length; n++) {
					if (needComma) s.push(",");
					s.push(egl.toString(object[n]));
					needComma = true;
				}
				s.push("]");
				return s.join('');
			}
			catch (e) {
			}
		}
		if (object.eze$$package) {
			if (object.eze$$package == "egl.jsrt" && object.eze$$typename == "String") {
				return '<font color=blue>"' + object + '"</font>';
			}
			if (object.eze$$DOMElement) {
				return object.eze$$package +"." + object.eze$$typename +
					"[domElement=" + object.eze$$DOMElement.tagName + 
						",class=" + object.eze$$DOMElement.className +
						",#children=" + object.eze$$DOMElement.childNodes.length + "]";
			}
			else if (object.eze$$package == "egl.ui.rui" && object.eze$$typename == "Widget") {
				return object.eze$$package + "." + object.eze$$typename + '-<b><font color=red>NO DOM ELEMENT!!!</font></b>';
			}
			else {
				return object.eze$$package + "." + object.eze$$typename;
			}
		}
		if (object.eze$$value)
			return "ANY["+egl.inferSignature(object)+"]";
			
		return egl.inferSignature(object);
	}
	catch (e) {
		return "<font color=red>Cannot call toString on "+object+" due to "+e+"</font>";
	}
};

egl.enter = function() { }
egl.leave = function() { }
egl.lastFile;
egl.lastLine;
egl.atLine = function() { }
egl.showEditingFeedback = function() { }

egl.startNewWork = function() {
	//if (egl.debugg) return;
	//egl.workStartTime = new Date().getTime();
};
egl.checkWork = function() {
	//if (egl.debugg) return;
	//var now = new Date().getTime();
	//if ((now - egl.workStartTime > 20000)) {
	//	if (!confirm("This EGL program has been running for a long time. Press OK to continue. Press Cancel to stop it."))
	//		throw egl.createRuntimeException( "CRRUI2016E", [] );
	//	egl.workStartTime = now; 
	//}
};

egl.startup = function(){
	egl.startNewWork();
};
