/*
 * Licensed Materials - Property of IBM
 *
 * Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA DP Schedule Contract with IBM Corp.
 */

egl.createIndexOutOfBoundsException = function( /*string*/ messageID, /*string or array*/ inserts )
{
	if (typeof(inserts) != "string") {
		inserts = egl.getRuntimeMessage( messageID, inserts );
	}
	egl.exceptionThrown = true;
	var args = new Array();
	args.push( [ "messageID", messageID || "" ] );
	args.push( [ "message", inserts || "" ] );
	args.push( [ "indexValue", arguments[ 2 ] || 0 ] );
	return new egl.egl.core.IndexOutOfBoundsException( args );
}

egl.defineClass( "egl.core", "IndexOutOfBoundsException", "egl.core", "AnyException", {
	
	//IndexOutOfBoundsException requires the following additional data:
	//indexValue
	
	"eze$$getChildVariables" : function() {
		var childVars = this.eze$$superClass.prototype.eze$$getChildVariables.call( this );
		childVars.push({name : "indexValue", value : this.indexValue, type : "int"});
		return childVars;
	}
	
});
