/*
 * Licensed Materials - Property of IBM
 *
 * Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA DP Schedule Contract with IBM Corp.
 */

egl.createInvocationException = function( /*string*/ messageID, /*string or array*/ inserts )
{
	if (typeof(inserts) != "string") {
		inserts = egl.getRuntimeMessage( messageID, inserts );
	}
	egl.exceptionThrown = true;
	var args = new Array();
	args.push( [ "messageID", messageID || "" ] );
	args.push( [ "message", inserts || "" ] );
	args.push( [ "name", arguments[ 2 ] || "" ] );
	args.push( [ "returnValue", arguments[ 3 ] || "" ] );
	return new egl.egl.core.InvocationException( args );
}

egl.defineClass( "egl.core", "InvocationException", "egl.core", "AnyException", {
	
	//InvocationException requires the following additional data:
	//name
	//returnValue
	
	"constructor" : function() {
		//first two arguments are forwarded to superclass constructor
		this.name = "";
		this.returnValue = "";
		
		if (arguments.length == 4) {
			this.name = arguments[2];
			this.returnValue = arguments[3];
		}
	},
	
	"eze$$getChildVariables" : function() {
		var childVars = this.eze$$superClass.prototype.eze$$getChildVariables.call( this );
		childVars.push({name : "name", value : this.name, type : "string"});
		return childVars;
	}

});
