/*
 * Licensed Materials - Property of IBM
 *
 * Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA DP Schedule Contract with IBM Corp.
 */

egl.createLobProcessingException = function( /*string*/ messageID, /*string or array*/ inserts )
{
	if (typeof(inserts) != "string") {
		inserts = egl.getRuntimeMessage( messageID, inserts );
	}
	egl.exceptionThrown = true;
	var args = new Array();
	args.push( [ "messageID", messageID || "" ] );
	args.push( [ "message", inserts || "" ] );
	args.push( [ "itemName", arguments[ 2 ] || "" ] );
	args.push( [ "operation", arguments[ 3 ] || "" ] );
	args.push( [ "resource", arguments[ 4 ] || "" ] );
	return new egl.egl.core.LobProcessingException( args );
}

egl.defineClass( "egl.core", "LobProcessingException", "egl.core", "AnyException", {
	
	//LobProcessingException requires the following additional data:
	//itemName
	//operation
	//resource
	
	"eze$$getChildVariables" : function() {
		var childVars = this.eze$$superClass.prototype.eze$$getChildVariables.call( this );
		childVars.push({name : "itemName", value : this.itemName, type : "int"});
		childVars.push({name : "operation", value : this.operation, type : "int"});
		childVars.push({name : "resource", value : this.resource, type : "int"});
		return childVars;
	}
	
});
