/*
 * Licensed Materials - Property of IBM
 *
 * Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA DP Schedule Contract with IBM Corp.
 */

egl.createServiceInvocationException = function( /*string*/ messageID, /*string or array*/ inserts )
{
	if (typeof(inserts) != "string") {
		inserts = egl.getRuntimeMessage( messageID, inserts );
	}
	egl.exceptionThrown = true;
	var args = new Array();
	args.push( [ "messageID", messageID || "" ] );
	args.push( [ "message", inserts || "" ] );
	args.push( [ "source", arguments[ 2 ] || egl.core.ServiceKind.EGL ] );
	var detail1 = "";	
	if(arguments[ 3 ])
		detail1 = arguments[ 3 ]+''; //make sure it's String
	var detail2= "";
	if(arguments[ 4 ])
		detail2 = arguments[ 4 ]+''; //make sure it's String
	var detail3= "";
	if(arguments[ 5 ])
		detail3 = arguments[ 5 ]+''; //make sure it's String
	args.push( [ "detail1", detail1] );		
	args.push( [ "detail2", detail2] );		
	args.push( [ "detail3", detail3] );	
	return new egl.egl.core.ServiceInvocationException( args );
}

egl.defineClass( "egl.core", "ServiceInvocationException", "egl.core", "AnyException", {
	
	//ServiceInvocationException requires the following additional data:
	//source (serviceKind)
	//detail1
	//detail2
	//detail3
	
	"eze$$getChildVariables" : function() {
		var childVars = this.eze$$superClass.prototype.eze$$getChildVariables.call( this );
		childVars.push({name : "source", value : this.source, type : "enumeration"});
		childVars.push({name : "detail1", value : this.detail1, type : "string"});
		childVars.push({name : "detail2", value : this.detail2, type : "string"});
		childVars.push({name : "detail3", value : this.detail3, type : "string"});
		return childVars;
	}
	
});
