/*
 * Licensed Materials - Property of IBM
 *
 * Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA DP Schedule Contract with IBM Corp.
 */

egl.createTypeCastException = function( /*string*/ messageID, /*string or array*/ inserts )
{
	if (typeof(inserts) != "string") {
		inserts = egl.getRuntimeMessage( messageID, inserts );
	}
	egl.exceptionThrown = true;
	var args = new Array();
	args.push( [ "messageID", messageID || "" ] );
	args.push( [ "message", inserts || "" ] );
	args.push( [ "castToName", arguments[ 2 ] || "" ] );
	args.push( [ "actualTypeName", arguments[ 3 ] || "" ] );
	return new egl.egl.core.TypeCastException( args );
}

egl.defineClass( "egl.core", "TypeCastException", "egl.core", "AnyException", {
	
	//LobProcessingException requires the following additional data:
	//castToName
	//actualTypeName
	
	"eze$$getChildVariables" : function() {
		var childVars = this.eze$$superClass.prototype.eze$$getChildVariables.call( this );
		childVars.push({name : "castToName", value : this.castToName, type : "string"});
		childVars.push({name : "actualTypeName", value : this.actualTypeName, type : "string"});
		return childVars;
	}
	
});
