/*
 * Licensed Materials - Property of IBM
 *
 * Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA DP Schedule Contract with IBM Corp.
 */
egl.defineClass( "egl.javascript", "Job", {
	"constructor" : function() {
		egl.jobs.push(this);
	},
	"getName" : function() {
		return this.name;
	},
	"setName" : function(/*String*/ name) {
		this.name = name;
	},
	"getRunFunction" : function() {
		return this.runFunction;
	},
	"setRunFunction" : function(/*function*/ runFunction) {
		this.runFunction = runFunction;
	},
	"schedule" : function(/*int*/ms) {
		this.cancel();
		var job = this;
		this.timeout = setTimeout(function() {
			if (job.runFunction)
				try {
					job.runFunction();
				}
				catch(e) {
					if (window.egl) egl.printError("@ Job.schedule("+(ms?ms:"")+")", e);
				}
		}, ms);
	},
	"repeat" : function(/*int*/ms) {
		this.cancel();
		var job = this;
		this.interval = setInterval(function() {
			if (job.runFunction)
				try {
					job.runFunction();
				}
				catch(e) {
					if (window.egl) egl.printError("@ Job.repeat("+(ms?ms:"")+")", e);
				}
		}, ms);
	},
	"cancel" : function() {
		if (this.interval)
			clearInterval(this.interval);
		if (this.timeout)
			clearTimeout(this.timeout);
	},
	"eze$$getChildVariables": function() {
		return [
			{name: "name", value : this.name, type : "string"},
			{name: "runFunction", value : this.runFunction, type : "egl.javascript.RunFunction"}
		];
	}
});
