/*
 * Licensed Materials - Property of IBM
 *
 * Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA DP Schedule Contract with IBM Corp.
 */
egl.defineClass( 'egl.jsrt', 'ServiceBinder', {
	
    "constructor" : function() { 
        if (egl.egl.jsrt.$ServiceBinder) return egl.egl.jsrt.$ServiceBinder;
		egl.egl.jsrt.$ServiceBinder=this; 
        this.bindFiles = [];
    }, 
	"addBindFile" : function(/*String*/ eglddName) {
	    if (!this.bindFileExists(eglddName)) {
			this.loadBindFile(eglddName);
	    }
	},
	"bindFileExists" : function(/*String*/ eglddName) {
		var rc = false;
		for(var n=0; n < this.bindFiles && rc == false; n++) {
			if (this.bindFiles.name == eglddName) {
			   rc = true;
			}			
		}
		return rc;
	},
	"loadBindFile" : function(/*String*/ eglddName) {
        var bindFileVar = "eze$$BindFile_" + eglddName;
	    var bindFile = egl[bindFileVar]();
	    this.bindFiles.push(bindFile);
	},
	"getBinding" : function(/*String*/ eglddName, /*String*/ bindingKey) {
	    var bindFile = null;
	    for (var n = 0; n < this.bindFiles.length && bindFile == null; n++) {
	        if (this.bindFiles[n].name == eglddName) {
	           bindFile = this.bindFiles[n];
	        }
	    }
	    if (bindFile == null) {
	    	//can not find eglddName
	    	throw egl.createServiceBindingException("CRRUI3650E", [eglddName]);
	       return null;
	    }
	    
		var binding = null;
		for (var n=0; n < bindFile.bindings.length && binding == null; n++) {
			if (bindingKey == bindFile.bindings[n].name) {
				binding = bindFile.bindings[n];
			}			
		}
		if(binding == null){
			//can not find binding key
			throw egl.createServiceBindingException("CRRUI3651E", [bindingKey, eglddName]);
		}
		return binding;
	}
});

egl.defineClass( "egl.jsrt", "BindFile", {
    "constructor" : function(/*String*/ eglddName) { 
		this.name = eglddName; 
        this.bindings = [];
    }
});

egl.defineClass( "egl.jsrt", "WebBinding", {
    "constructor" : function(/*String*/ _name,
                             /*String*/ _interface,
                             /*String*/ _wsdlLocation,
                             /*String*/ _wsdlService,
                             /*String*/ _wsdlPort,
                             /*String*/ _uri) {
        this.type = "web";
        this.name = _name;
        this._interface = _interface;
        this.wsdlLocation = _wsdlLocation;
        this.wsdlService = _wsdlService;
        this.wsdlPort = _wsdlPort;
        this.uri = _uri;
    },
    
    "createServiceWrapper" : function(){
    	return new egl.egl.jsrt.SOAPServiceRefWrapper(
    			this._interface,
    			this.name,
    			this.wsdlLocation,
    			this.wsdlService,
    			this.wsdlPort,
    			this.uri);
    }

});

egl.defineClass( "egl.jsrt", "RestBinding", {
    "constructor" : function(/*String*/ _name,
                             /*String*/ _baseURI,
                             /*String*/ _sessionCookieId) {
        this.type = "rest";
        this.name = _name;
        this.baseURI = _baseURI;
        this.sessionCookieId = _sessionCookieId;
    },
    
    "createServiceWrapper" : function(){
    	return new egl.egl.jsrt.RESTServiceRefWrapper(
    			this.name,
    			this.baseURI,
    			this.sessionCookieId);
    }
});
new egl.egl.jsrt.ServiceBinder();
