/*
 * Licensed Materials - Property of IBM
 *
 * Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA DP Schedule Contract with IBM Corp.
 */
egl.defineClass(
	'egl.ui.rui', 'Document',
	{
	"setOnKeyDown" : function(handler) { document.onkeydown = function (e) { handler(egl.wrapEvent(e)) } },
	"setOnKeyPress" : function(handler) { document.onkeypress = function (e) { handler(egl.wrapEvent(e)) } },
	"setOnKeyUp" : function(handler) { document.onkeyup = function (e) { handler(egl.wrapEvent(e)) } },
	"setOnMouseDown" : function(handler) { document.onmousedown = function (e) { handler(egl.wrapEvent(e)) } },
	"setOnMouseMove" : function(handler) { document.onmousemove = function (e) { handler(egl.wrapEvent(e)) } },
	"setOnMouseOver" : function(handler) { document.onmouseover = function (e) { handler(egl.wrapEvent(e)) } },
	"setOnMouseOut" : function(handler) { document.onmouseout = function (e) { handler(egl.wrapEvent(e)) } },
	"setOnMouseUp" : function(handler) { document.onmouseup = function (e) { handler(egl.wrapEvent(e)) } },
	"setOnScroll" : function(handler) { document.onscroll = function (e) { handler(egl.wrapEvent(e)) } },
	"setOnChange" : function(handler) { document.onchange = function (e) { handler(egl.wrapEvent(e)) } },						
	"setOnClick" : function(handler) { document.onclick = function (e) { handler(egl.wrapEvent(e)) } },	

	"setOnSelectStart" : function(handler) { document.onselectstart = function (e) { handler(egl.wrapEvent(e)) } },						
	"setOnDragStart" : function(handler) { document.ondragstart = function (e) { handler(egl.wrapEvent(e)) } },						
	
	"getLocation" : function() {
		return ""+document.location;
	},
	"setLocation" : function(loc) {
		document.location = loc;
	},
	
	"eze$$getChildVariables": function() {
		return [
			{name: "body", value : egl.Document.body, type : "egl.ui.rui.Widget"},
			{name: "location", value : this.getLocation(), type : "string"},
			{name: "onChange", value : document.onchange, type : "egl.ui.rui.EventHandler"},
			{name: "onClick", value : document.onclick, type : "egl.ui.rui.EventHandler"},
			{name: "onDragStart", value : document.ondragstart, type : "egl.ui.rui.EventHandler"},
			{name: "onKeyDown", value : document.onkeydown, type : "egl.ui.rui.EventHandler"},
			{name: "onKeyPress", value : document.onkeypress, type : "egl.ui.rui.EventHandler"},
			{name: "onKeyUp", value : document.onkeyup, type : "egl.ui.rui.EventHandler"},
			{name: "onMouseDown", value : document.onmousedown, type : "egl.ui.rui.EventHandler"},
			{name: "onMouseMove", value : document.onmousemove, type : "egl.ui.rui.EventHandler"},
			{name: "onMouseOut", value : document.onmouseout, type : "egl.ui.rui.EventHandler"},
			{name: "onMouseOver", value : document.onmouseover, type : "egl.ui.rui.EventHandler"},
			{name: "onMouseUp", value : document.onmouseup, type : "egl.ui.rui.EventHandler"},
			{name: "onScroll", value : document.onscroll, type : "egl.ui.rui.EventHandler"},
			{name: "onSelectStart", value : document.onselectstart, type : "egl.ui.rui.EventHandler"}
		];
	}
});

egl.Document = egl.Document || new egl.egl.ui.rui.Document();
egl.Document.body = egl.createWidget(document.body);
